##############################################################################
#
# vc/src/tcl/diagrm.tcl
#
# Roof Module Diagnostics screen
#
# 20041109 QC - created
#
# Copyright (c) 2004 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it in Exit

    frame .ftop
    
    frame .ftop.display
    
    label .ftop.display.l -text "Roof Module Diagnostics" -font $huge_font
    
    canvas .ftop.display.c1 -width 154 -height 160 -relief sunken \
                           -borderwidth 1 -background $color6
    .ftop.display.c1 create text 75 20 -text "Receiver Status" \
                           -font $big_font -fill black
    .ftop.display.c1 create text 67 85 -text "\n\n\n    Loading..." -tag rxStatus 

    #.ftop.display.c1 create line 0 30 154 30 -fill black -width 1
    #.ftop.display.c1 create text 40 55 -text "GPS1 L1" -font $medium_font
    #.ftop.display.c1 create image 105 55 -image btnGREEN
    #.ftop.display.c1 create image 130 55 -image btnQUESTION
    #.ftop.display.c1 create text 40 85 -text "GPS1 L2" -font $medium_font
    #.ftop.display.c1 create image 105 85 -image btnGREEN
    #.ftop.display.c1 create image 130 85 -image btnQUESTION
    #.ftop.display.c1 create text 40 115 -text "GPS2 L1" -font $medium_font
    #.ftop.display.c1 create image 105 115 -image btnGREEN
    #.ftop.display.c1 create image 130 115 -image btnQUESTION
    #.ftop.display.c1 create text 40 145 -text "GPS2 L2" -font $medium_font
    #.ftop.display.c1 create image 105 145 -image btnGREEN
    #.ftop.display.c1 create image 130 145 -image btnQUESTION

    canvas .ftop.display.c2 -width 154 -height 160 -relief sunken \
                           -borderwidth 1 -background $color6
    .ftop.display.c2 create text 75 20 -text "Antenna Status" \
                           -font $big_font -fill black
    .ftop.display.c2 create text 80 80 -text "\n\n\n    Loading..." -tag antStatus
    #.ftop.display.c2 create line 0 30 154 30 -fill black -width 1
    #.ftop.display.c2 create text 42 55 -text "GPS1 L1" -font $medium_font
    #.ftop.display.c2 create image 100 55 -image btnGREEN
    #.ftop.display.c2 create image 130 55 -image btnQUESTION
    #.ftop.display.c2 create text 42 85 -text "GPS1 L2" -font $medium_font
    #.ftop.display.c2 create image 100 85 -image btnGREEN
    #.ftop.display.c2 create image 130 85 -image btnQUESTION
    #.ftop.display.c2 create text 42 115 -text "GPS2 L1" -font $medium_font
    #.ftop.display.c2 create image 100 115 -image btnGREEN
    #.ftop.display.c2 create image 130 115 -image btnQUESTION
    #.ftop.display.c2 create text 42 145 -text "GPS2 L2" -font $medium_font
    #.ftop.display.c2 create image 100 145 -image btnGREEN
    #.ftop.display.c2 create image 130 145 -image btnQUESTION

    canvas .ftop.display.c3 -width 154 -height 160 -relief sunken \
                           -borderwidth 1 -background $color6
    .ftop.display.c3 create text 75 20 -text "Attitude Status" \
                           -font $big_font -fill black
    #.ftop.display.c3 create line 0 30 154 30 -fill black -width 1
    .ftop.display.c3 create text 43 55 -text "Heading" -font $medium_font
    .ftop.display.c3 create image 100 55 -image btnRED -tag headingLight 
    #.ftop.display.c3 create image 130 55 -image btnQUESTION
    .ftop.display.c3 create text 30 85 -text "Roll" -font $medium_font
    .ftop.display.c3 create text 100 85 -text "+0.0000" -tag roll
    .ftop.display.c3 create text 34 115 -text "Pitch" -font $medium_font
    .ftop.display.c3 create text 100 115 -text "+0.0000" -tag pitch
    .ftop.display.c3 create text 30 145 -text "Yaw" -font $medium_font
    .ftop.display.c3 create text 100 145 -text "+0.0000" -tag yaw

    canvas .ftop.display.c4 -width 154 -height 160 -relief sunken \
                           -borderwidth 1 -background $color6
    .ftop.display.c4 create text 75 20 -text "Position Status" \
                           -font $big_font -fill black
    #.ftop.display.c4 create line 0 30 154 30 -fill black -width 1
    .ftop.display.c4 create text 45 55 -text "Position" -font $medium_font
    .ftop.display.c4 create image 100 55 -image btnRED -tag posLight
    #.ftop.display.c4 create image 130 55 -image btnQUESTION
    .ftop.display.c4 create text 27 85 -text "Lat" -font $medium_font
    .ftop.display.c4 create text 100 85 -text "+0.0000" -tag lat
    .ftop.display.c4 create text 30 115 -text "Lon" -font $medium_font
    .ftop.display.c4 create text 100 115 -text "+0.0000" -tag lon
    .ftop.display.c4 create text 27 145 -text "Alt" -font $medium_font
    .ftop.display.c4 create text 100 145 -text "+0.0000" -tag alt

    pack .ftop.display.l -side top -pady 5
    pack .ftop.display.c1 -side left -anchor nw
    pack .ftop.display.c2 -side left -anchor nw
    pack .ftop.display.c3 -side left -anchor nw
    pack .ftop.display.c4 -side left -anchor nw
    pack .ftop.display -side top
    
    frame .ftop.display2
    canvas .ftop.display2.c -width 630 -height 120 -relief sunken \
                            -borderwidth 1 -background $color6
    .ftop.display2.c create text 212 55 -text "\n\n\n     Loading..." -font $medium_font -tag rmstatus
#    .ftop.display2.c create text 112 35 -text "Number of Resets:" -font $medium_font
#    .ftop.display2.c create text 424 35 -text "Number of Assertions:" -font $medium_font
#    .ftop.display2.c create text 109 55 -text "Temperature: " -font $medium_font
#    .ftop.display2.c create text 424 55 -text "Supply Voltage: " -font $medium_font
#    .ftop.display2.c create text 105 75 -text "BaseStation OK Message: " \
#                                        -font $medium_font -tag msg5
#    .ftop.display2.c create text 425 75 -text "Num of Satellites Tracked: " \
#                                        -font $medium_font -tag msg6
#    .ftop.display2.c create text 104 95 -text "Percent Packet Received: " \
#                                        -font $medium_font -tag msg7
#    .ftop.display2.c create text 435 95 -text "Temperature of Roof Module: " \
#                                        -font $medium_font -tag msg8
                                                                
    pack .ftop.display2.c -side bottom
    pack .ftop.display2 -side top 
    
    frame .ftop.input
    pack .ftop.input -side bottom -padx 5 -pady 5 -fill both -expand yes
    canvas .ftop.input.c -width 405 -height 110 -relief sunken \
                            -borderwidth 0 -background $color6
    .ftop.input.c create image 100 20 -image btnGREEN -tag pingImage
    .ftop.input.c create text 200 20 -text "Ping Test Result" \
                            -font $medium_font -tag pingTag
    .ftop.input.c create text 205 65 -text "" -font $medium_font -tag pingTxt
                                                    
    SnazzyButton::create .ftop.input.exit btnKhakiU btnKhakiD 0.5 \
           "beepOnce; post $DISP_BTN9_SIG 9;" "Return\nTo\nPrevious\nMenu"
    pack .ftop.input.exit -side left -anchor sw
    pack .ftop.input.c -side left -anchor sw

    #scrollbar .ftop.input.sbar -command { .ftop.input.lbox yview }
    #text .ftop.input.lbox -yscrollcommand {.ftop.input.sbar set} \
    #                      -font $text_font -background white \
    #                      -width 77 -height 7
    #pack .ftop.input.sbar -side right -pady 5 -fill y

    #.ftop.input.lbox insert end "Error(s) Detected:\n"
    #.ftop.input.lbox insert end "Antenna Error: GPS2 L1 GPS2 L2 not working\n"
    #.ftop.input.lbox insert end "Heading Error: System couldn't determine heading\n"
    #.ftop.input.lbox insert end "                        May be the result of the Antenna error\n"
    #.ftop.input.lbox insert end "Position Error: System couldn't determine position\n"
    #.ftop.input.lbox insert end "                        May be the result of the Antenna error\n"
    #.ftop.input.lbox insert end "Solution:\n"
    #.ftop.input.lbox insert end "  1. Confirm that the Antenna is connected properly\n"
    #.ftop.input.lbox insert end "  2. Replace the Antenna\n"
    #.ftop.input.lbox insert end "  3. Contact your service representative for further assistance\n\n"
    
                           
    #pack .ftop.input.lbox -side left
    
    SnazzyButton::create .ftop.input.continue btnBlueU btnBlueD 0.5 \
                           "beepOnce; post $DISP_BTN1_SIG 1;" "Ping\nTest"   
    pack .ftop.input.continue -side right -anchor se

    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry {rxTypeLbl} {

      .ftop.display.l configure -text $rxTypeLbl
      pack .ftop -fill both -expand yes
    }
    
    # Action called by GuiMgr on exit from this screen
    proc actExit {} {

        destroy .ftop

    }
   
    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------
    # Update procedures of this template can be called by the GuiMgr
    proc actEnablePingBtn {} {

        .ftop.input.continue configure -state normal

    }

    proc actDisablePingBtn {} {

        .ftop.input.continue configure -state disabled
        .ftop.input.c itemconfigure pingTag -text "Pinging Roof Module"
        .ftop.input.c itemconfigure pingImage -image btnGREY
        .ftop.input.c itemconfigure pingTxt -text ""

    }

    proc actPingResult {num1 num2} {
        if {$num1 == $num2} {
          .ftop.input.c itemconfigure pingTag -text "Ping Successful"
          .ftop.input.c itemconfigure pingImage -image btnGREEN
          .ftop.input.c itemconfigure pingTxt -text "Packets: Sent = $num1, Received = $num2, Lost = 0 <0% Loss>"
        }
        if {$num1 != $num2} {
          .ftop.input.c itemconfigure pingTag -text "Ping Failed"
          .ftop.input.c itemconfigure pingImage -image btnRED
          set lostpkt [expr $num1 - $num2]
          set lostpercent [expr $lostpkt/$num1*100]
          .ftop.input.c itemconfigure pingTxt -text "Packets: Sent = $num1, Received = $num2, Lost = $lostpkt <$lostpercent% loss>"
        }

    }

    proc actDisplayRoll {roll} {

        .ftop.display.c3 itemconfigure roll -text $roll

    }

    proc actDisplayPitch {pitch} {

        .ftop.display.c3 itemconfigure pitch -text $pitch

    }

    proc actDisplayYaw {yaw} {

        .ftop.display.c3 itemconfigure yaw -text $yaw

    }

    proc actConfigLat {lat} {

        .ftop.display.c4 itemconfigure lat -text $lat

    }

    proc actConfigLon {lon} {

        .ftop.display.c4 itemconfigure lon -text $lon

    }

    proc actConfigAlt {alt} {

        .ftop.display.c4 itemconfigure alt -text $alt

    }

    proc actDisplayDiag { info } {

        .ftop.display2.c itemconfigure rmstatus -text $info

    }

    proc actDisplayRxStatus { info } {

        .ftop.display.c1 itemconfigure rxStatus -text $info

    }

    proc actDisplayAntStatus { info } {

        .ftop.display.c2 itemconfigure antStatus -text $info

    }


    proc actConfigPosLight { info } {

        if {$info == 0} {
          .ftop.display.c4 itemconfigure posLight -image btnRED
        }
        if {$info == 1} {
          .ftop.display.c4 itemconfigure posLight -image btnYELLOW
        }
        if {$info == 2} {
          .ftop.display.c4 itemconfigure posLight -image btnGREEN
        }

    }

    proc actConfigHeadingLight { info } {

        if {$info == 0} {
          .ftop.display.c3 itemconfigure headingLight -image btnRED
        }
        if {$info == 1} {
          .ftop.display.c3 itemconfigure headingLight -image btnYELLOW
        }
        if {$info == 2} {
          .ftop.display.c3 itemconfigure headingLight -image btnGREEN
        }

    }
}




