##############################################################################
#
# vc/src/tcl/guessrow.tcl
#
# AutoFarm Setup screen
#
# 20021024 QC - created
#
# Copyright (c) 2002 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it in sExit
    frame .ftop
    
    # Row 1
    frame .ftop.r1
    frame .ftop.r1.c1
    label .ftop.r1.c1.l -wraplength 386 -justify left -font $big_font
    pack .ftop.r1.c1.l -side left -pady 5
    
    frame .ftop.r1.c2

    set width  188
    set height 188
    canvas .ftop.r1.c2.c -width $width -height $height -relief sunken \
            -borderwidth 1 -background $color6
    # Rows
    .ftop.r1.c2.c create line [expr $width*0.1] [expr $height/4] \
                              [expr $width*0.1] [expr $height*3/4] 
    .ftop.r1.c2.c create line [expr $width*0.4] [expr $height/4] \
                              [expr $width*0.4] [expr $height*3/4] 
    .ftop.r1.c2.c create line [expr $width*0.7] [expr $height/2] \
                              [expr $width*0.7] [expr $height*3/4] 
    # Arcs
    .ftop.r1.c2.c create arc  [expr $width*0.1] [expr $height/8] \
                              [expr $width*0.4] [expr $height*3/8] \
                             -style arc -start 0 -extent 180
    .ftop.r1.c2.c create arc  [expr $width*0.4] [expr $height*5/8] \
                              [expr $width*0.7] [expr $height*7/8] \
                             -style arc -start 180 -extent 180
    # Arrows
    set arrow 5
    .ftop.r1.c2.c create line [expr $width*0.1] [expr $height*5/8] \
                            [expr $width*0.1+$arrow] [expr $height*5/8+$arrow] 
    .ftop.r1.c2.c create line [expr $width*0.1] [expr $height*5/8] \
                            [expr $width*0.1-$arrow] [expr $height*5/8+$arrow] 
    .ftop.r1.c2.c create line [expr $width*0.4] [expr $height*3/8] \
                            [expr $width*0.4+$arrow] [expr $height*3/8-$arrow] 
    .ftop.r1.c2.c create line [expr $width*0.4] [expr $height*3/8] \
                            [expr $width*0.4-$arrow] [expr $height*3/8-$arrow] 
    .ftop.r1.c2.c create line [expr $width*0.7] [expr $height*5/8] \
                            [expr $width*0.7+$arrow] [expr $height*5/8+$arrow] 
    .ftop.r1.c2.c create line [expr $width*0.7] [expr $height*5/8] \
                            [expr $width*0.7-$arrow] [expr $height*5/8+$arrow] 
    
    pack .ftop.r1.c2.c -side right
    pack .ftop.r1.c1 -side left -padx 15
    pack .ftop.r1.c2 -side right -padx 26

    # Row 2
    frame .ftop.r2 
    label .ftop.r2.l -font $big_font
    pack .ftop.r2.l -side top -pady 5

    # Row 3
    frame .ftop.r3
    SnazzyButton::create .ftop.r3.cancel btnKhakiU btnKhakiD 0.5 \
        "beepOnce; post $DISP_BTN9_SIG 9;" "Cancel\nGuess Row\nAdjustment"
    SnazzyButton::create .ftop.r3.b1 btnBlueU btnBlueD 0.5 \
        "beepOnce; post $DISP_BTN1_SIG 1;" "Left\nGuess Row\nToo Wide"
    SnazzyButton::create .ftop.r3.b2 btnBlueU btnBlueD 0.5 \
        "beepOnce; post $DISP_BTN2_SIG 2;" "Perfect\nGuess Rows"
    SnazzyButton::create .ftop.r3.b3 btnBlueU btnBlueD 0.5 \
        "beepOnce; post $DISP_BTN3_SIG 3;" "Right\nGuess Row\nToo Wide"       
#    button .ftop.r3.cancel -text "Cancel\nGuess Row\nAdjustment" \
#            -width 10 -height 6 \
#            -background $color5 -activebackground $color5 \
#            -command {beepOnce; post $DISP_BTN9_SIG 9; }
#    button .ftop.r3.b1 -text "Left\nGuess Row\nToo Wide" \
#            -height 6 -width 10 \
#            -background $color3 -activebackground $color3 \
#            -command {beepOnce; post $DISP_BTN1_SIG 1; }
#    button .ftop.r3.b2 -text "Perfect\nGuess Rows" \
#            -height 6 -width 10 \
#            -background $color3 -activebackground $color3 \
#            -command {beepOnce; post $DISP_BTN2_SIG 2; }
#    button .ftop.r3.b3 -text "Right\nGuess Row\nToo Wide" \
#            -height 6 -width 10 \
#            -background $color3 -activebackground $color3 \
#            -command {beepOnce; post $DISP_BTN3_SIG 3; }
    pack .ftop.r3.cancel -side left
    pack .ftop.r3.b3 -side right -padx 12
    pack .ftop.r3.b2 -side right -padx 12
    pack .ftop.r3.b1 -side right -padx 12

    # Pack rows
    pack .ftop.r3 -side bottom -padx 16 -pady 5 -expand yes -fill both
    pack .ftop.r1 -side top -pady 18 -fill both -expand yes
    pack .ftop.r2 -side top -fill both -expand yes

    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry { msg1 msg2 cancelBtn leftBtn perfectBtn rightBtn 
                    tractorType tractorColor implOffs} {
        .ftop.r1.c1.l configure -text $msg1
        .ftop.r2.l configure -text $msg2
        SnazzyButton::setText .ftop.r3.cancel $cancelBtn 0.5
        SnazzyButton::setText .ftop.r3.b1 $leftBtn 0.5
        SnazzyButton::setText .ftop.r3.b2 $perfectBtn 0.5
        SnazzyButton::setText .ftop.r3.b3 $rightBtn 0.5
#        .ftop.r3.cancel configure -text $cancelBtn
#        .ftop.r3.b1 configure -text $leftBtn
#        .ftop.r3.b2 configure -text $perfectBtn
#        .ftop.r3.b3 configure -text $rightBtn
        
        # draw the tractor with implement
        global Screen::width
        TractorDisplay::drawTractor .ftop.r1.c2.c \
          [expr $Screen::width*0.7 - $implOffs] [expr $Screen::height/2 - 20]\
          $tractorType $tractorColor 50 $implOffs
        
        pack .ftop -fill both -expand yes
    }
    
    # Action called by GuiMgr on exit from this screen
    proc actExit {} {

        destroy .ftop

    }


    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------
    # Update procedures of this template can be called by the GuiMgr



    #-------------------------------------------------------------------------
    # Local procedures
    #-------------------------------------------------------------------------
    proc ToBeCompleted {} {

    }

}
