##############################################################################
#
# vc/src/tcl/jobDisplay.tcl
#
# Screen to display details about and edit an existing job. Used when
# adding or editing an job.
#
# 20021003 QC - created
#
# Copyright (c) 2002 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it on exit
    frame .ftop

    # Define and pack the screen layout

    # Title
    label .ftop.title -text "??Space for title"

    # Input frame
    frame .ftop.input

    # Row Name
    frame .ftop.input.rname
    label .ftop.input.rname.l -text "Name:" -font $big_font \
                -width 18 -anchor e
    label .ftop.input.rname.e -text "foo" -font $big_font \
                -width 32 -anchor w -relief sunken -borderwidth 2
    SnazzyButton::create .ftop.input.rname.b btnBlueMU btnBlueMD \
               0.5 "beepOnce; post $DISP_BTN2_SIG 2;" "Change"
#    button .ftop.input.rname.b -text "Change" -justify right \
#            -height 2 -width 8 \
#            -background $color3 -activebackground $color3 \
#            -command {beepOnce; post $DISP_BTN2_SIG 2; } 
    pack .ftop.input.rname.l -side left -pady 5
    pack .ftop.input.rname.e -side left -padx 10 -pady 5
    pack .ftop.input.rname.b -side right -pady 5
       
    # Row Nudge
    frame .ftop.input.rnudge
    label .ftop.input.rnudge.l -text "Nudge:" -font $big_font \
                -width 18 -anchor e
    label .ftop.input.rnudge.e -text "0" -font $big_font \
                -width 32 -anchor w -relief sunken -borderwidth 2
    SnazzyButton::create .ftop.input.rnudge.b btnBlueMU btnBlueMD \
             0.5 "beepOnce; post $DISP_BTN3_SIG 3;" "Change"
#    button .ftop.input.rnudge.b -text "Change" -justify right \
#            -height 2 -width 8 \
#            -background $color3 -activebackground $color3 \
#            -command {beepOnce; post $DISP_BTN3_SIG 3; } 
    pack .ftop.input.rnudge.l -side left -pady 5 -anchor w
    pack .ftop.input.rnudge.e -side left -padx 10 -pady 5
    pack .ftop.input.rnudge.b -side right -pady 5
    
    # Row Number of Rows
    frame .ftop.input.rnum
    label .ftop.input.rnum.l -text "Number of Rows:" -font $big_font \
                  -width 18 -anchor e
    label .ftop.input.rnum.e -text "0" -font $big_font \
                  -width 32 -anchor w -relief sunken -borderwidth 2
    SnazzyButton::create .ftop.input.rnum.b btnBlueMU btnBlueMD \
                0.5 "beepOnce; post $DISP_BTN4_SIG 4;" "Change"
#    button .ftop.input.rnum.b -text "Change" -justify right \
#            -height 2 -width 8 \
#            -background $color3 -activebackground $color3 \
#            -command {beepOnce; post $DISP_BTN4_SIG 4; }
    pack .ftop.input.rnum.l -side left -pady 5
    pack .ftop.input.rnum.e -side left -padx 10 -pady 5
    pack .ftop.input.rnum.b -side right -pady 5
    
    # Row North Coordinate
    frame .ftop.input.rnorth
    label .ftop.input.rnorth.l -text "North Coordinate:" -font $big_font \
            -width 18 -anchor e
    label .ftop.input.rnorth.e -text "0 feet" -font $big_font \
                  -width 32 -anchor w -relief sunken -borderwidth 2
    pack .ftop.input.rnorth.l -side left -pady 5 -anchor w
    pack .ftop.input.rnorth.e -side left -padx 10 -pady 5

    # Row East Coordinate
    frame .ftop.input.reast
    label .ftop.input.reast.l -text "East Coordinate:" -font $big_font \
            -width 18 -anchor e
    label .ftop.input.reast.e -text "0 feet" -font $big_font \
                  -width 32 -anchor w -relief sunken -borderwidth 2
    pack .ftop.input.reast.l -side left -pady 5 -anchor w
    pack .ftop.input.reast.e -side left -padx 10 -pady 5

    # Row Heading
    frame .ftop.input.rheading
    label .ftop.input.rheading.l -text "Heading:" -font $big_font \
            -width 18 -anchor e
    label .ftop.input.rheading.e -text "0 degrees" -font $big_font \
                  -width 32 -anchor w -relief sunken -borderwidth 2
    pack .ftop.input.rheading.l -side left -pady 5 -anchor w
    pack .ftop.input.rheading.e -side left -padx 10 -pady 5

    # Row Max spacing
    frame .ftop.input.rmax
    label .ftop.input.rmax.l -text "Max Spacing:" -font $big_font \
            -width 18 -anchor e
    label .ftop.input.rmax.e -text "0 degrees" -font $big_font \
                  -width 32 -anchor w -relief sunken -borderwidth 2
    pack .ftop.input.rmax.l -side left -pady 5 -anchor w
    pack .ftop.input.rmax.e -side left -padx 10 -pady 5

    # Row Min spacing
    frame .ftop.input.rmin
    label .ftop.input.rmin.l -text "Min Spacing:" -font $big_font \
            -width 18 -anchor e
    label .ftop.input.rmin.e -text "0 degrees" -font $big_font \
                  -width 32 -anchor w -relief sunken -borderwidth 2
    pack .ftop.input.rmin.l -side left -pady 5 -anchor w
    pack .ftop.input.rmin.e -side left -padx 10 -pady 5

    # Pack rows
    pack .ftop.input.rname -side top -anchor w -fill x
    pack .ftop.input.rnudge -side top -anchor w -fill x
    
    # Cancel/Accept frame
    frame .ftop.input2
    SnazzyButton::create .ftop.input2.cancel btnKhakiU btnKhakiD \
            0.5 "beepOnce; post $DISP_BTN0_SIG 0;" "Cancel"
    SnazzyButton::create .ftop.input2.accept btnBlueU btnBlueD 0.5 \
            "beepOnce; post $DISP_BTN1_SIG 1;" "Accept"       
#    button .ftop.input2.cancel -text "Cancel" \
#            -width 10 -height 6 \
#            -background $color5 -activebackground $color5 \
#            -command {beepOnce; post $DISP_BTN0_SIG 0; }
#    button .ftop.input2.accept -text "Accept" \
#            -width 10 -height 6 \
#            -background $color3 -activebackground $color3 \
#            -command {beepOnce; post $DISP_BTN1_SIG 1; }
        
    pack .ftop.input2.cancel -side left -padx 10 -pady 10
    pack .ftop.input2.accept -side right -padx 10 -pady 10

    # Pack .ftop
    pack .ftop.title -side top -pady 10 -fill both -expand yes
    pack .ftop.input -side top -pady 10 -pady 5
    pack .ftop.input2 -side bottom -anchor se -fill both -expand yes
                
    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry { packProc__ } {

        eval $packProc__
        pack .ftop -fill both -expand yes

    }


    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }

    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------
    proc actDisplayStraight {name nudge nCoordinate eCoordinate heading} {
        .ftop.input.rname.e configure -text $name
        .ftop.input.rnudge.e configure -text $nudge
        .ftop.input.rnorth.e configure -text $nCoordinate
        .ftop.input.reast.e configure -text $eCoordinate
        .ftop.input.rheading.e configure -text $heading
    }

    proc actDisplayFan {name nudge numofrows maxspacing minspacing} {
        .ftop.input.rname.e configure -text $name
        .ftop.input.rnudge.e configure -text $nudge
        .ftop.input.rnum.e configure -text $numofrows
        .ftop.input.rmax.e configure -text $maxspacing
        .ftop.input.rmin.e configure -text $minspacing
    }

    proc actDisplayBox {name nudge} {
        .ftop.input.rname.e configure -text $name
        .ftop.input.rnudge.e configure -text $nudge
    }

    proc actDisplayCircle {name nudge} {
        .ftop.input.rname.e configure -text $name
        .ftop.input.rnudge.e configure -text $nudge
    }

    proc actDisplayCurve {name nudge} {
        .ftop.input.rname.e configure -text $name
        .ftop.input.rnudge.e configure -text $nudge
    }

    #-------------------------------------------------------------------------
    # Delegated procedures
    #-------------------------------------------------------------------------

    #-------------------------------------------------------------------------
    # Local procedures
    # {MLE-020418: Tcl/Tk goal should be to get rid of all local procedures, 
    # because they represent intelligence, which the display should not have.}
    #-------------------------------------------------------------------------
    # Local procedures
    proc packEdit {editLbl jobType nameLbl nudgeLbl \
                   northLbl eastLbl headingLbl numofrowsLbl maxLbl minLbl \
                   cancelBtn acceptBtn changeBtn} {

        .ftop.title configure -text $editLbl
        .ftop.input.rname.l configure -text $nameLbl
        SnazzyButton::setText .ftop.input.rname.b $changeBtn 0.5
#        .ftop.input.rname.b configure -text $changeBtn
        .ftop.input.rnudge.l configure -text $nudgeLbl
        SnazzyButton::setText .ftop.input.rnudge.b $changeBtn 0.5
#        .ftop.input.rnudge.b configure -text $changeBtn
        SnazzyButton::setText .ftop.input2.cancel $cancelBtn 0.5
        SnazzyButton::setText .ftop.input2.accept $acceptBtn 0.5
#        .ftop.input2.cancel configure -text $cancelBtn
#        .ftop.input2.accept configure -text $acceptBtn
        
        if {$jobType == 0} {
          pack .ftop.input.rnorth -side top -anchor w -fill x
          pack .ftop.input.reast -side top -anchor w -fill x
          pack .ftop.input.rheading -side top -anchor w -fill x
        } elseif {$jobType == 1} {
          pack .ftop.input.rnum -side top -anchor w -fill x
          pack .ftop.input.rmax -side top -anchor w -fill x
          pack .ftop.input.rmin -side top -anchor w -fill x
        }
    }
}
