##############################################################################
#
# vc/src/tcl/offsetselect.tcl
#
# A modal-dialog for implement offset select.
#
# 20021106 QC - created
#
# Copyright (c) 2002 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Modal { 

    #-------------------------------------------------------------------------
    # Define and pack the offsetselect
    #-------------------------------------------------------------------------
    # Top level frame
    frame .fmodal

    # display frame
    frame .fmodal.display
    label .fmodal.display.prompt -text "Space for the prompt"

    # Input frame
    frame .fmodal.input
    SnazzyButton::create .fmodal.input.cancel btnKhakiU btnKhakiD 0.5 \
                         "beepOnce; post $DISP_BTN0_SIG 0" "Cancel"
#    button .fmodal.input.cancel -text "Cancel" -width 10 -height 6 \
#            -background $color5 -activebackground $color5 \
#            -command {beepOnce; post $DISP_BTN0_SIG 0}

    # Row 2
    frame .fmodal.input.r2
    
    set canvasWidth 100
    set canvasHeight 100
    
    frame .fmodal.input.r2.c1
    canvas .fmodal.input.r2.c1.c -width $canvasWidth -height $canvasHeight \
            -borderwidth 1 -background $color6
    SnazzyButton::create .fmodal.input.r2.c1.b btnBlueU btnBlueD 0.5 \
                         "beepOnce; post $DISP_BTN4_SIG 4" "Default"          
#    button .fmodal.input.r2.c1.b -text "Default" -width 10 -height 6 \
#            -background $color3 -activebackground $color3 \
#            -command {beepOnce; post $DISP_BTN4_SIG 4}
    
    frame .fmodal.input.r2.c2
    canvas .fmodal.input.r2.c2.c -width $canvasWidth -height $canvasHeight \
            -borderwidth 1 -background $color6
    SnazzyButton::create .fmodal.input.r2.c2.b btnBlueU btnBlueD 0.5 \
                         "beepOnce; post $DISP_BTN5_SIG 5" "Default"       
#    button .fmodal.input.r2.c2.b -text "Default" -width 10 -height 6 \
#            -background $color3 -activebackground $color3 \
#            -command {beepOnce; post $DISP_BTN5_SIG 5}

    frame .fmodal.input.r2.c3
    canvas .fmodal.input.r2.c3.c -width $canvasWidth -height $canvasHeight \
            -borderwidth 1 -background $color6
    SnazzyButton::create .fmodal.input.r2.c3.b btnBlueU btnBlueD 0.5 \
                         "beepOnce; post $DISP_BTN6_SIG 6" "Default"
#    button .fmodal.input.r2.c3.b -text "Default" -width 10 -height 6 \
#            -background $color3 -activebackground $color3 \
#            -command {beepOnce; post $DISP_BTN6_SIG 6}

    #pack
    pack .fmodal.display -side top -pady 30 -fill x -expand yes
    pack .fmodal.display.prompt -side top -fill both -expand yes
    pack .fmodal.input -side top -fill both -expand yes
    
    pack .fmodal.input.cancel -side left -padx 20 -pady 60 -anchor sw
    
    pack .fmodal.input.r2 -side bottom -padx 40 -pady 60 -anchor se
    pack .fmodal.input.r2.c1 -side left -padx 10
    pack .fmodal.input.r2.c1.c -side top -pady 10
    pack .fmodal.input.r2.c1.b -side top
       
    pack .fmodal.input.r2.c2 -side left -padx 10
    pack .fmodal.input.r2.c2.c -side top -pady 10
    pack .fmodal.input.r2.c2.b -side top
     
    pack .fmodal.input.r2.c3 -side left -padx 10        
    pack .fmodal.input.r2.c3.c -side top -pady 10
    pack .fmodal.input.r2.c3.b -side top
    

    #-------------------------------------------------------------------------
    # Entry and exit procedures
    #-------------------------------------------------------------------------
    proc actEntry {} {
        pack forget .ftop
        pack .fmodal -fill both -expand yes
    }

    proc actExit {} {
        destroy .fmodal
        pack .ftop -fill both -expand yes
    }

    #-------------------------------------------------------------------------
    # Action procedures
    #-------------------------------------------------------------------------
    proc actConfigure { prompt cancelBtn btn1Label btn2Label btn3Label \
                        tractorType tractorColor } {
       
        .fmodal.display.prompt configure -text $prompt
        SnazzyButton::setText .fmodal.input.cancel $cancelBtn 0.5
        SnazzyButton::setText .fmodal.input.r2.c1.b $btn1Label 0.5
        SnazzyButton::setText .fmodal.input.r2.c2.b $btn2Label 0.5
        SnazzyButton::setText .fmodal.input.r2.c3.b $btn3Label 0.5       
#        .fmodal.input.cancel configure -text $cancelBtn
#        .fmodal.input.r2.c1.b configure -text $btn1Label
#        .fmodal.input.r2.c2.b configure -text $btn2Label
#        .fmodal.input.r2.c3.b configure -text $btn3Label
     
        TractorDisplay::drawTractor .fmodal.input.r2.c1.c \
          [expr $Modal::canvasWidth/2] [expr $Modal::canvasHeight - 30] \
          $tractorType $tractorColor 50 -10
 
        TractorDisplay::drawTractor .fmodal.input.r2.c2.c \
          [expr $Modal::canvasWidth/2] [expr $Modal::canvasHeight - 30] \
          $tractorType $tractorColor 50 0
 
        TractorDisplay::drawTractor .fmodal.input.r2.c3.c \
          [expr $Modal::canvasWidth/2] [expr $Modal::canvasHeight - 30] \
          $tractorType $tractorColor 50 10
        
    }
  
    #-------------------------------------------------------------------------
    # Local procedures
    # {MLE-020418: Tcl/Tk goal should be to get rid of all local procedures, 
    # because they represent intelligence, which the display should not have.}
    #-------------------------------------------------------------------------
}
