##############################################################################
#
# al/src/tcl/calibration.tcl
#
# autolevel calibration screen
#
# 20050610  DEH Created
#
# Copyright (c) 2005 Novariant
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it in sExit
    frame .ftop

    # Title
    label .ftop.title -text "AutoLevel Scraper Configuration" -font $huge_font
    pack .ftop.title -side top

    # Input frame
    frame .ftop.input

    # Control subframe
    frame .ftop.input.control
    # Cancel Button
    button .ftop.input.control.cancel \
            -text "Cancel" \
            -command { beepOnce; post $DISP_BTN9_SIG 0 } \
            -width 8 -height 3 \
            -background $color0 -activebackground $color0
    pack .ftop.input.control.cancel -side left -anchor s -padx 10 -pady 5
    # Up Button
    button .ftop.input.control.up \
            -text "UP" \
            -command { beepOnce; post $DISP_BTN1_SIG 0 } \
            -width 8 -height 3 \
            -background $color5 -activebackground $color5
    pack .ftop.input.control.up -side left -anchor s -padx 10 -pady 5
    # Down Button
    button .ftop.input.control.down \
            -text "DOWN" \
            -command { beepOnce; post $DISP_BTN2_SIG 0 } \
            -width 8 -height 3 \
            -background $color5 -activebackground $color5
    pack .ftop.input.control.down -side left -anchor s -padx 10 -pady 5
    # Stop Button
    button .ftop.input.control.stop \
            -text "STOP" \
            -command { beepOnce; post $DISP_BTN3_SIG 0 } \
            -width 8 -height 3 \
            -background $color5 -activebackground $color5
    pack .ftop.input.control.stop -side left -anchor s -padx 10 -pady 5
    # Pack the Input Frame
    pack .ftop.input.control -side right -expand no

    # Create a canvas where we can plot the calibration
    canvas .ftop.calPlot -width 300 -height 300 -relief sunken \
            -borderwidth 1 -background gray85


    # Slider and Nudge container
    frame .ftop.sn

    # Slider frame
    frame .ftop.sn.sliders
    pack .s2 -in .ftop.sn.sliders -side top
    raise .s2
    pack .s3 -in .ftop.sn.sliders -side top
    raise .s3
    pack .s4 -in .ftop.sn.sliders -side top
    raise .s4
    pack .s5 -in .ftop.sn.sliders -side top
    raise .s5
    pack .s6 -in .ftop.sn.sliders -side top
    raise .s6


    pack .ftop.sn.sliders -side bottom

    # Pack the various elements
    pack .ftop.input -side bottom -expand false
    pack .ftop.calPlot -side right -padx 10 -pady 10
    pack .ftop.sn -side left -expand false

    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry { userLevel__ } {
	pack forget ftop.sn.s2
        pack .ftop -fill both -expand yes
#        x-axis                   x   y   x   y
        .ftop.calPlot create line 0 150 300 150 -stipple gray50
#        y-axis
        .ftop.calPlot create line 150 0 150 300 -stipple gray50
#	if { $userLevel__ != "S" } {
#	}
    }

    proc actDrawLine { x1 y1 x2 y2 } {
	.ftop.calPlot create line  $x1 $y1 $x2 $y2 -fill magenta -width 2
    }

    proc actClearPlot {} {
	foreach id [.ftop.calPlot find all] {
	    .ftop.calPlot delete $id
	}
#        x-axis                   x   y   x   y
        .ftop.calPlot create line 0 150 300 150 -stipple gray50
#        y-axis
        .ftop.calPlot create line 150 0 150 300 -stipple gray50
    }
    
    proc actConfigDriver {} {
	pack forget ftop.sn
    }
    # Action called by GuiMgr on exit from this screen
    proc actExit {} {

        destroy .ftop

    }

}
