##############################################################################
#
# vc/src/tcl/backlightWarning.tcl
#
# 20050524 RA - created
#
# Copyright (c) 2005 Novariant Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it on exit
    frame .ftop

    # Define and pack the screen layout
    # (Screen has custom display and input frames
    # .configDisplay, and .navDisplay components)
    frame .ftop.display         ;# Display Frame
    frame .ftop.input           ;# Input Frame
    pack .ftop.input -side bottom -fill both -expand yes -anchor s
    pack .ftop.display -side bottom -fill both -expand yes

    SnazzyButton::create .ftop.input.confirm btnKhakiU btnKhakiD 0.5 \
            "beepOnce; post $DISP_BTN0_SIG 0" "Confirm"

    # Display Frame - displays up to 5 lines of text
    label .ftop.display.title -text "line 0"

    # pack fields
    pack .ftop.display.title -side top -padx 30 -pady 50
    pack .ftop.input.confirm -side bottom -padx 5 -pady 5

    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry { title confirmBtn } {
       .ftop.display.title configure -text $title
       SnazzyButton::setText .ftop.input.confirm $confirmBtn 0.5
        pack .ftop -fill both -expand yes
    }

    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }

    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------

}
