##############################################################################
#
# sync/src/tcl/selectbase.tcl
#
# Screen to display selectbase selections
#
# RA - created
#
# Copyright (c) 2005 Novariant Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    # image create photo ExclamationPoint -format gif -file ExclamationPoint.gif

    # screen3 manual menu ........................................................
    frame .ftop -width 600 -height 455

    label .ftop.title -font $huge_font -width 250 \
	-text "Synchronize Base Stations" -pady 10
    place .ftop.title -relx .5 -y 0 -anchor n

    image create photo btnBlueQuestionU -format gif -file \
	${tclPath}gif/btnBlueQuestionU.gif
    image create photo btnBlueQuestionD -format gif -file \
	${tclPath}gif/btnBlueQuestionD.gif

    SnazzyButton::create .ftop.help btnBlueQuestionU btnBlueQuestionD 0.5 \
                         "beepOnce; post $DISP_BTN0_SIG 0" ""

    place .ftop.help -relx 0.97 -y 5 -width 46 -height 46 -anchor ne

    frame .ftop.conflict -width 600 -height 400

    label .ftop.conflict.attention -font $big_font \
	-text "Attention: You are about to delete the following\nfields and jobs from your database:"
    place .ftop.conflict.attention -relx .5 -y 10 -anchor n

    label .ftop.conflict.title -font $medium_font -width 300
    place .ftop.conflict.title -relx .5 -y 55 -anchor n

    label .ftop.conflict.remoteLbl -text "On Your Sync Disk:" -font $medium_font 
    place .ftop.conflict.remoteLbl -relx 0.20 -y 90 -anchor n

    scrollbar .ftop.conflict.sbar1 -orient vertical \
	-command [list .ftop.conflict.remoteTxt yview] \
	-width 38 

    scrollbar .ftop.conflict.sbar2 -orient vertical \
	-command [list .ftop.conflict.localTxt yview] \
	-width 38

    listbox .ftop.conflict.remoteTxt -width 28 -height 16 -font $small_font \
	-exportselection 0 \
	-yscrollcommand [list .ftop.conflict.sbar1 set] \
	-background white -selectbackground gray

    place .ftop.conflict.sbar1 -relx 0.0 -y 110 -height 274   
    place .ftop.conflict.remoteTxt -relx 0.245 -y 110 -anchor n

    bind .ftop.conflict.remoteTxt <ButtonRelease-1> \
	{post $DISP_CANVAS1_SIG 1}

    label .ftop.conflict.localLbl -text "On Your GPS System:" -font $medium_font
    place .ftop.conflict.localLbl -relx 0.80 -y 90 -anchor n

    listbox .ftop.conflict.localTxt -width 28 -height 16 -font $small_font \
	-exportselection 0 \
	-yscrollcommand [list .ftop.conflict.sbar2 set] \
	-background white -selectbackground gray

    place .ftop.conflict.sbar2 -relx .925 -y 110 -height 274                             
    place .ftop.conflict.localTxt -relx 0.755 -y 110 -anchor n

    bind .ftop.conflict.localTxt <ButtonRelease-1> \
	{post $DISP_CANVAS0_SIG 0}

    SnazzyButton::create .ftop.conflict.viewFields btnBlueM2U btnBlueM2D \
	0.5 "beepOnce; post $DISP_BTN7_SIG 7" "Cancel"
	place .ftop.conflict.viewFields -relx 0.501 -y 245 -anchor n

    SnazzyButton::create .ftop.conflict.finished btnBlueM2U btnBlueM2D \
	0.5 "beepOnce; post $DISP_BTN8_SIG 8" "Okay"
    place .ftop.conflict.finished -relx 0.501 -y 320 -anchor n

    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry {basename} {
	global huge_font color3

	.ftop.conflict.attention configure -text \
 "Attention: You are about to delete the following\nfields and jobs from base station \"$basename\""
	place .ftop.conflict -relx 0.04 -y 50
        pack .ftop -fill both -expand yes
    }


    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
        pack .ftop -fill both -expand yes
    }

    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------

    proc actListboxInsert { where item } {
	#puts "selectBase -- insert $item"
	$where insert end $item
    }

    proc actClearListBoxes {} {
	.ftop.conflict.localTxt delete 0 end
	.ftop.conflict.remoteTxt delete 0 end
    }
}