##############################################################################
#
# vc/src/tcl/diagrm.tcl
#
# Roof Module Diagnostics screen
#
# 20041109 QC - created
#
# Copyright (c) 2004 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it in Exit

    frame .ftop
    
    frame .ftop.display
    
    label .ftop.display.l -text "Roof Module Diagnostics" -font $huge_font
    
    canvas .ftop.display.c1 -width 154 -height 160 -relief sunken \
                           -borderwidth 1 -background $color6
    .ftop.display.c1 create text 75 20 -text "Receiver Status" \
                           -font $big_font -fill black -tag rxLabel
    .ftop.display.c1 create text 67 85 -text "\n\n\n    Loading..." -tag rxStatus 

    canvas .ftop.display.c2 -width 154 -height 160 -relief sunken \
                           -borderwidth 1 -background $color6
    .ftop.display.c2 create text 75 20 -text "Antenna Status" \
                           -font $big_font -fill black -tag antLabel
    .ftop.display.c2 create text 80 80 -text "\n\n\n    Loading..." -tag antStatus

    canvas .ftop.display.c3 -width 154 -height 160 -relief sunken \
                           -borderwidth 1 -background $color6
    .ftop.display.c3 create text 75 20 -text "Attitude Status" \
                           -font $big_font -fill black -tag attLabel
    
    .ftop.display.c3 create text 43 55 -text "Heading" \
	                   -font $medium_font -tag headingLabel
    .ftop.display.c3 create image 100 55 -image btnRED -tag headingLight 
    
    .ftop.display.c3 create text 30 85 -text "Roll" \
                           -font $medium_font -tag rollLabel
    .ftop.display.c3 create text 100 85 -text "+0.0000" -tag roll
    .ftop.display.c3 create text 34 115 -text "Pitch" \
	                   -font $medium_font -tag pitchLabel
    .ftop.display.c3 create text 100 115 -text "+0.0000" -tag pitch
    .ftop.display.c3 create text 30 145 -text "Yaw" \
	                    -font $medium_font -tag yawLabel
    .ftop.display.c3 create text 100 145 -text "+0.0000" -tag yaw

    canvas .ftop.display.c4 -width 154 -height 160 -relief sunken \
                           -borderwidth 1 -background $color6
    .ftop.display.c4 create text 75 20 -text "Position Status" \
                            -font $big_font -fill black -tag posStatusLabel
    
    .ftop.display.c4 create text 45 55 -text "Position" \
	                    -font $medium_font -tag posLabel
    .ftop.display.c4 create image 100 55 -image btnRED -tag posLight
    .ftop.display.c4 create text 27 85 -text "Lat" \
	                    -font $medium_font -tag latLabel
    .ftop.display.c4 create text 100 85 -text "+0.0000" -tag lat
    .ftop.display.c4 create text 30 115 -text "Lon" \
	                    -font $medium_font -tag lonLabel
    .ftop.display.c4 create text 100 115 -text "+0.0000" -tag lon
    .ftop.display.c4 create text 27 145 -text "Alt" \
                                        -font $medium_font -tag altLabel
    .ftop.display.c4 create text 100 145 -text "+0.0000" -tag alt

    pack .ftop.display.l -side top -pady 5
    pack .ftop.display.c1 -side left -anchor nw
    pack .ftop.display.c2 -side left -anchor nw
    pack .ftop.display.c3 -side left -anchor nw
    pack .ftop.display.c4 -side left -anchor nw
    pack .ftop.display -side top
    
    frame .ftop.display2 
    frame .ftop.display2.left
    frame .ftop.display2.left.text 
    frame .ftop.display2.left.value 
    frame .ftop.display2.right
    frame .ftop.display2.right.text
    frame .ftop.display2.right.value
    
    label .ftop.display2.left.text.rmserialnumtxt -text \
      "Roof Module Serial Number" -font $medium_font
    label .ftop.display2.left.value.rmserialnumval -text "0000000" \
      -font $medium_font -relief sunken -width 10
    label .ftop.display2.left.text.numresetstxt -text "Number of Resets" \
      -font $medium_font
    label .ftop.display2.left.value.numresetsval -text "N/A" \
      -font $medium_font -relief sunken -width 10
    label .ftop.display2.left.text.numassertstxt -text "Number of Asserts" \
      -font $medium_font
    label .ftop.display2.left.value.numassertsval -text "N/A" \
      -font $medium_font -relief sunken -width 10
    label .ftop.display2.left.text.rmtemptxt -text "Roof Module Temperature" \
      -font $medium_font
    label .ftop.display2.left.value.rmtempval -text "N/A" \
      -font $medium_font -relief sunken -width 10
    
    
    
    label .ftop.display2.right.text.rmbundlevertxt -text \
      "Roof Module Bundle Version" -font $medium_font
    label .ftop.display2.right.value.rmbundleverval -text "N/A" \
      -font $medium_font -relief sunken -width 10
    label .ftop.display2.right.text.processortxt -text "X86 Processor" \
      -font $medium_font
    label .ftop.display2.right.value.processorval -text "N/A" \
      -font $medium_font -relief sunken -width 10
    label .ftop.display2.right.text.almanactxt -text "Almanac" \
      -font $medium_font
    label .ftop.display2.right.value.almanacval -text "N/A" \
      -font $medium_font -relief sunken -width 10
    label .ftop.display2.right.text.supplyvoltagetxt -text "Supply Voltage" \
      -font $medium_font
    label .ftop.display2.right.value.supplyvoltageval -text "N/A" \
      -font $medium_font -relief sunken -width 10
    
    
    # Pack left side text and value frames
    pack .ftop.display2.left.text -side left -anchor nw
    pack .ftop.display2.left.value -side right -anchor ne -padx 3
    
    # Pack left side text and values
    pack .ftop.display2.left.text.rmserialnumtxt -side top -anchor nw -pady 3
    pack .ftop.display2.left.value.rmserialnumval -side top -anchor ne -pady 3
    pack .ftop.display2.left.text.numresetstxt -side top -anchor nw -pady 3
    pack .ftop.display2.left.value.numresetsval -side top -anchor ne -pady 3
    pack .ftop.display2.left.text.numassertstxt -side top -anchor nw -pady 3
    pack .ftop.display2.left.value.numassertsval -side top -anchor ne -pady 3 
    pack .ftop.display2.left.text.rmtemptxt -side top -anchor nw -pady 3
    pack .ftop.display2.left.value.rmtempval -side top -anchor ne -pady 3
    
    # Pack right side text and value frames
    pack .ftop.display2.right.text -side left -anchor nw
    pack .ftop.display2.right.value -side right -anchor ne -padx 3
    
    # Pack right side text and values
    pack .ftop.display2.right.text.rmbundlevertxt -side top -anchor nw -pady 3
    pack .ftop.display2.right.value.rmbundleverval -side top -anchor ne -pady 3
    pack .ftop.display2.right.text.processortxt -side top -anchor nw -pady 3
    pack .ftop.display2.right.value.processorval -side top -anchor ne -pady 3
    pack .ftop.display2.right.text.almanactxt -side top -anchor nw -pady 3
    pack .ftop.display2.right.value.almanacval -side top -anchor ne -pady 3
    pack .ftop.display2.right.text.supplyvoltagetxt -side top -anchor nw -pady 3
    pack .ftop.display2.right.value.supplyvoltageval -side top -anchor ne -pady 3
    
    pack .ftop.display2.left -side left -anchor nw -padx 15
    pack .ftop.display2.right -side right -anchor ne -padx 10                                                               
    pack .ftop.display2 -side top -pady 5 -expand yes -fill both 
    
    frame .ftop.input
    pack .ftop.input -side bottom -padx 5 -pady 5 -fill both -expand yes
    canvas .ftop.input.c -width 405 -height 110 -relief sunken \
                            -borderwidth 0 -background $color6
    .ftop.input.c create image 100 20 -image btnGREEN -tag pingImage
    .ftop.input.c create text 120 20 -text "Ping Test Result" \
                            -anchor w -font $medium_font -tag pingTag
    .ftop.input.c create text 205 65 -text "" -font $medium_font -tag pingTxt
                                                    
    SnazzyButton::create .ftop.input.exit btnKhakiU btnKhakiD 0.5 \
           "beepOnce; post $DISP_BTN9_SIG 9;" "Return\nTo\nPrevious\nMenu"
    pack .ftop.input.exit -side left -anchor sw
    pack .ftop.input.c -side left -anchor sw
    
    SnazzyButton::create .ftop.input.continue btnBlueU btnBlueD 0.5 \
                           "beepOnce; post $DISP_BTN1_SIG 1;" "Ping\nTest"   
    pack .ftop.input.continue -side right -anchor se

    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry {rxTypeLbl rx ant att head roll pitch yaw  
	           posStat pos lat lon alt sernum resets asserts 
		   temp bundle x86 almanac voltage ping pingbtn ret } {
	
      .ftop.display.l configure -text $rxTypeLbl
      pack .ftop -fill both -expand yes
      .ftop.display.c1 itemconfigure rxLabel -text $rx
      .ftop.display.c2 itemconfigure antLabel -text $ant 
      .ftop.display.c3 itemconfigure attLabel -text  $att
      .ftop.display.c3 itemconfigure headingLabel -text $head 
      .ftop.display.c3 itemconfigure rollLabel -text  $roll
      .ftop.display.c3 itemconfigure pitchLabel -text  $pitch
      .ftop.display.c3 itemconfigure yawLabel -text  $yaw
      .ftop.display.c4 itemconfigure posStatusLabel -text $posStat  
      .ftop.display.c4 itemconfigure posLabel -text $pos  
      .ftop.display.c4 itemconfigure latLabel -text  $lat
      .ftop.display.c4 itemconfigure lonLabel -text  $lon
      .ftop.display.c4 itemconfigure altLabel -text  $alt
      .ftop.display2.left.text.rmserialnumtxt configure -text $sernum
      .ftop.display2.left.text.numresetstxt configure -text $resets
      .ftop.display2.left.text.numassertstxt configure -text $asserts
      .ftop.display2.left.text.rmtemptxt configure -text $temp
      .ftop.display2.right.text.rmbundlevertxt configure -text $bundle
      .ftop.display2.right.text.processortxt configure -text $x86
      .ftop.display2.right.text.almanactxt configure -text $almanac
      .ftop.display2.right.text.supplyvoltagetxt configure -text $voltage
      .ftop.input.c itemconfigure pingTag -text $ping
      .ftop.input.exit configure -text $ret
      .ftop.input.continue configure -text $pingbtn
    }
    
    # Action called by GuiMgr on exit from this screen
    proc actExit {} {

        destroy .ftop

    }
   
    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------
    # Update procedures of this template can be called by the GuiMgr
    proc actEnablePingBtn {} {

        .ftop.input.continue configure -state normal

    }

    proc actDisablePingBtn { ping } {

        .ftop.input.continue configure -state disabled
        .ftop.input.c itemconfigure pingTag -text $ping
        .ftop.input.c itemconfigure pingImage -image btnGREY
        .ftop.input.c itemconfigure pingTxt -text ""

    }

    proc actPingResult {num1 num2} {
        if {$num1 == $num2} {
          .ftop.input.c itemconfigure pingTag -text "Ping Successful"
          .ftop.input.c itemconfigure pingImage -image btnGREEN
          .ftop.input.c itemconfigure pingTxt -text "Packets: Sent = $num1, Received = $num2, Lost = 0 <0% Loss>"
        }
        if {$num1 != $num2} {
          .ftop.input.c itemconfigure pingTag -text "Ping Failed"
          .ftop.input.c itemconfigure pingImage -image btnRED
          set lostpkt [expr $num1 - $num2]
          set lostpercent [expr $lostpkt/$num1*100]
          .ftop.input.c itemconfigure pingTxt -text "Packets: Sent = $num1, Received = $num2, Lost = $lostpkt <$lostpercent% loss>"
        }

    }

    proc actDisplayRoll {roll} {

        .ftop.display.c3 itemconfigure roll -text $roll

    }

    proc actDisplayPitch {pitch} {

        .ftop.display.c3 itemconfigure pitch -text $pitch

    }

    proc actDisplayYaw {yaw} {

        .ftop.display.c3 itemconfigure yaw -text $yaw

    }

    proc actConfigLat {lat} {

        .ftop.display.c4 itemconfigure lat -text $lat

    }

    proc actConfigLon {lon} {

      .ftop.display.c4 itemconfigure lon -text $lon

    }

    proc actConfigAlt {alt} {

      .ftop.display.c4 itemconfigure alt -text $alt

    }

    proc actDisplayDiag { serialNumTxt serialNumVal numResetTxt numResetVal \
                          numAssertTxt numAssertVal rmTempTxt rmTempVal\
                          processorTxt processorVal almanacTxt almanacVal \
                          supplyVoltageTxt supplyVoltageVal } {
      # Configure left side data
      .ftop.display2.left.text.rmserialnumtxt configure \
        -text $serialNumTxt
      .ftop.display2.left.value.rmserialnumval configure \
        -text $serialNumVal 
      .ftop.display2.left.text.numresetstxt configure \
        -text $numResetTxt
      .ftop.display2.left.value.numresetsval configure \
        -text $numResetVal
      .ftop.display2.left.text.numassertstxt configure \
        -text $numAssertTxt
      .ftop.display2.left.value.numassertsval configure \
        -text $numAssertVal 
      .ftop.display2.left.text.rmtemptxt configure \
        -text $rmTempTxt
      .ftop.display2.left.value.rmtempval configure \
        -text $rmTempVal
          
      # Configure right side data
      .ftop.display2.right.text.processortxt configure \
        -text $processorTxt
      .ftop.display2.right.value.processorval configure \
        -text $processorVal
      .ftop.display2.right.text.almanactxt configure \
        -text $almanacTxt
      .ftop.display2.right.value.almanacval configure \
        -text $almanacVal
      .ftop.display2.right.text.supplyvoltagetxt configure \
        -text $supplyVoltageTxt
      .ftop.display2.right.value.supplyvoltageval configure \
        -text $supplyVoltageVal
    }

    proc actDisplayRxStatus { info } {
      .ftop.display.c1 itemconfigure rxStatus -text $info
    }

    proc actDisplayAntStatus { info } {
      .ftop.display.c2 itemconfigure antStatus -text $info
    }
    
    proc actDisplayBundleVersion {rmBundleVerTxt rmBundleVerVal} {
      .ftop.display2.right.text.rmbundlevertxt configure \
        -text $rmBundleVerTxt
      .ftop.display2.right.value.rmbundleverval configure \
        -text $rmBundleVerVal
    }


    proc actConfigPosLight { info } {
      if {$info == 0} {
        .ftop.display.c4 itemconfigure posLight -image btnRED
      }
      if {$info == 1} {
        .ftop.display.c4 itemconfigure posLight -image btnYELLOW
      }
      if {$info == 2} {
        .ftop.display.c4 itemconfigure posLight -image btnGREEN
      }
    }

    proc actConfigHeadingLight { info } {
      if {$info == 0} {
        .ftop.display.c3 itemconfigure headingLight -image btnRED
      }
      if {$info == 1} {
        .ftop.display.c3 itemconfigure headingLight -image btnYELLOW
      }
      if {$info == 2} {
        .ftop.display.c3 itemconfigure headingLight -image btnGREEN
      }
    }
}




