##############################################################################
#
# vc/src/tcl/error.tcl
#
# Indemnity warning screen,
#
# 20030109 M_E - created
#
# Copyright (c) 2003 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it on exit
    frame .ftop

    # title and error indicator
    label .ftop.title -text "ERROR"
    place .ftop.title -relx 0.5 -rely 0.1 -anchor n
    label .ftop.diag -text "file line" -width 50 -height 4 \
          -font $medium_font -relief sunken -border 2
    place .ftop.diag -relx 0.5 -rely 0.5 -anchor c

    # exit button
    button .ftop.exit -text "Exit Program" \
            -width 10 -height 6 \
            -command { beepOnce; post $DISP_BTN9_SIG 9 } \
            -background $color0 -activebackground $color0
    place .ftop.exit -relx 0.5 -rely 1.0 -y -40 -anchor s

    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry {title exitBtn diagMsg diagLine} {
        .ftop.title configure -text $title
        .ftop.exit configure -text $exitBtn
        .ftop.diag configure -text "$diagMsg\n$diagLine"
        pack .ftop -fill both -expand yes
    }

    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }

}
