##############################################################################
#
# vc/src/tcl/error.tcl
#
# Indemnity warning screen,
#
# 20030109 M_E - created
#
# Copyright (c) 2003 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it on exit
    frame .ftop

    # title and error indicator
    label .ftop.title -text "Error Log"
    place .ftop.title -relx 0.5 -rely 0.06 -anchor n
    label .ftop.buildDetails -text "Build details" -font $medium_font
    place .ftop.buildDetails -relx 0.5 -rely 0.125 -anchor n
    
    # error log output
    frame .ftop.out
    scrollbar .ftop.out.sbar \
            -command { .ftop.out.lbox yview }
    listbox .ftop.out.lbox -width 70 -height 12 -font $small_font \
            -yscrollcommand {.ftop.out.sbar set}
    pack .ftop.out.lbox -side left -pady 5 -fill both -expand yes
    pack .ftop.out.sbar -side left -pady 5 -fill y -expand yes
    place .ftop.out -relx 0.5 -rely 0.5 -y -40 -anchor c

    # buttons
    button .ftop.clear -text "Clear Log" \
            -width 10 -height 6 \
            -background $color0 -activebackground $color0a \
            -command { beepOnce; post $DISP_BTN1_SIG 1 }
    place .ftop.clear -relx 0.5 -x -10 -rely 1.0 -y -15 -anchor se
    button .ftop.cont -text "Continue" \
            -width 10 -height 6 \
            -background $color5 -activebackground $color5 \
            -command { beepOnce; post $DISP_BTN9_SIG 9 } 
    place .ftop.cont -relx 0.5 -x 10 -rely 1.0 -y -15 -anchor sw

    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    
    set theLogFname ""
    proc actEntry {fname buildDetails} {
        global theLogFname
        
        puts "#### $fname"

        .ftop.buildDetails configure -text $buildDetails
        
        set theLogFname $fname
        set fd 0
        if [catch {open $fname r} fd] {
           set fd 0
           .ftop.out.lbox insert end "empty"           
        } else {
           gets $fd str
           while {$str != ""} {
               .ftop.out.lbox insert end $str           
               gets $fd str
           }
           catch {close $fd}
        }
        .ftop.out.lbox see end
        pack .ftop -fill both -expand yes
    }

    proc actClear {} {
        global theLogFname
        file delete $theLogFname
        .ftop.out.lbox delete 0 end           
        .ftop.out.lbox insert end "empty"           
        .ftop.out.lbox see end
    }

    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }

}
