##############################################################################
#
# vc/src/tcl/examineGpsMav.tcl
#
# Screen to display details about Position examination.
#
# 20030613 M_S - created
# 20041015 Q_C - modified
#
# Copyright (c) 2002-2004 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it on exit
    frame .ftop

    # NOTE: using place for positioning imported frames (-in option)
    #       craches Tcl interpreter. Therefore pack must be used.
    pack .navDisplay -in .ftop -side right -anchor n -padx 10 -pady 10
    raise .navDisplay

    # I/O summary
    set ioRelX 0.20 
    set ioRelY 0.08 
    label .ftop.linkLbl -text "Link" -font $medium_font
    place .ftop.linkLbl -relx $ioRelX -x 0 -rely $ioRelY -y -25 -anchor ne
    label .ftop.gmtLbl -text "GMT" -font $medium_font
    place .ftop.gmtLbl -relx $ioRelX -x 87 -rely $ioRelY -y -25 -anchor ne
    label .ftop.satsLbl -text "Sats" -font $medium_font
    place .ftop.satsLbl -relx $ioRelX -x 187 -rely $ioRelY -y -25 -anchor ne
    label .ftop.serialLbl -text "Serial Num" -font $medium_font
    place .ftop.serialLbl -relx $ioRelX -x 302 -rely $ioRelY -y -25 -anchor ne
    
    label .ftop.cab1Lbl -text "Cab1" -font $medium_font -foreground black
    place .ftop.cab1Lbl -relx $ioRelX -x -40 -rely $ioRelY -y 0 -anchor ne
    label .ftop.cab1L1Lbl -text "L1" -font $medium_font -foreground blue
    place .ftop.cab1L1Lbl -relx $ioRelX -x -20 -rely $ioRelY -y 0 -anchor ne
    label .ftop.cab1L2Lbl -text "L2" -font $medium_font -foreground purple
    place .ftop.cab1L2Lbl -relx $ioRelX -x 2 -rely $ioRelY -y 0 -anchor ne

    label .ftop.cab2Lbl -text "Cab2" -font $medium_font -foreground black
    place .ftop.cab2Lbl -relx $ioRelX -x -40 -rely $ioRelY -y 25 -anchor ne
    label .ftop.cab2L1Lbl -text "L1" -font $medium_font -foreground green3 
    place .ftop.cab2L1Lbl -relx $ioRelX -x -20 -rely $ioRelY -y 25 -anchor ne
    label .ftop.cab2L2Lbl -text "L2" -font $medium_font -foreground red
    place .ftop.cab2L2Lbl -relx $ioRelX -x 2 -rely $ioRelY -y 25 -anchor ne

    label .ftop.baseLbl -text "Base" -font $medium_font -foreground black
    place .ftop.baseLbl -relx $ioRelX -x -40 -rely $ioRelY -y 50 -anchor ne
    label .ftop.baseL1Lbl -text "L1" -font $medium_font -foreground gold3
    place .ftop.baseL1Lbl -relx $ioRelX -x -20 -rely $ioRelY -y 50 -anchor ne
    label .ftop.baseL2Lbl -text "L2" -font $medium_font -foreground black
    place .ftop.baseL2Lbl -relx $ioRelX -x 2 -rely $ioRelY -y 50 -anchor ne

    label .ftop.io11 -image btnRED 
    place .ftop.io11 -relx $ioRelX -x 26 -rely $ioRelY -y 0 -anchor ne
    label .ftop.io12 -width 13 -relief sunken -borderwidth 2 \
         -font $medium_font 
    place .ftop.io12 -relx $ioRelX -x 140 -rely $ioRelY -y 0 -anchor ne
    label .ftop.io13 -width 5 -relief sunken -borderwidth 2 -font $medium_font 
    place .ftop.io13 -relx $ioRelX -x 200 -rely $ioRelY -y 0 -anchor ne
    label .ftop.io14 -width 10 -relief sunken -borderwidth 2 \
                     -font $medium_font -text "" 
    place .ftop.io14 -relx $ioRelX -x 300 -rely $ioRelY -y 0 -anchor ne

    label .ftop.io21 -image btnRED 
    place .ftop.io21 -relx $ioRelX -x 26 -rely $ioRelY -y 25 -anchor ne
    label .ftop.io22 -width 13 -relief sunken -borderwidth 2 \
         -font $medium_font 
    place .ftop.io22 -relx $ioRelX -x 140 -rely $ioRelY -y 25 -anchor ne
    label .ftop.io23 -width 5 -relief sunken -borderwidth 2 -font $medium_font 
    place .ftop.io23 -relx $ioRelX -x 200 -rely $ioRelY -y 25 -anchor ne

    label .ftop.io31 -image btnRED 
    place .ftop.io31 -relx $ioRelX -x 26 -rely $ioRelY -y 50 -anchor ne
    label .ftop.io32 -width 13 -relief sunken -borderwidth 2 \
         -font $medium_font 
    place .ftop.io32 -relx $ioRelX -x 140 -rely $ioRelY -y 50 -anchor ne
    label .ftop.io33 -width 5 -relief sunken -borderwidth 2 -font $medium_font 
    place .ftop.io33 -relx $ioRelX -x 200 -rely $ioRelY -y 50 -anchor ne
    label .ftop.io34 -width 10 -relief sunken -borderwidth 2 \
         -font $medium_font -text "" 
    place .ftop.io34 -relx $ioRelX -x 300 -rely $ioRelY -y 50 -anchor ne

    # Distance to base station from vehicle
    label .ftop.baseDistTxt -text "Dist to Base:" -font $medium_font
    label .ftop.baseDist -text "0.0" -font $medium_font
    place .ftop.baseDistTxt -relx $ioRelX -x 10 -rely $ioRelY -y 75 -anchor ne
    place .ftop.baseDist -relx $ioRelX -x 110 -rely $ioRelY -y 75 -anchor ne
    
    # gps position summary
    set gpsRelX 0.36 
    set gpsRelY 0.37 
    label .ftop.latLbl -text "Vehicle Lat" -font $medium_font -justify left
    place .ftop.latLbl -relx $gpsRelX -x -17 -rely $gpsRelY -y -25 -anchor ne
    label .ftop.lonLbl -text "Vehicle Lon" -font $medium_font -justify left
    place .ftop.lonLbl -relx $gpsRelX -x -12 -rely $gpsRelY -y 0 -anchor ne
    label .ftop.altLbl -text "Vehicle Alt" -font $medium_font -justify left
    place .ftop.altLbl -relx $gpsRelX -x -18 -rely $gpsRelY -y 25 -anchor ne

    label .ftop.gps11 -width 20 -relief sunken -borderwidth 2 \
         -font $medium_font 
    place .ftop.gps11 -relx $gpsRelX -x 10 -rely $gpsRelY -y -25 -anchor nw
    label .ftop.gps21 -width 20 -relief sunken -borderwidth 2 \
         -font $medium_font 
    place .ftop.gps21 -relx $gpsRelX -x 10 -rely $gpsRelY -y 0 -anchor nw
    label .ftop.gps31 -width 20 -relief sunken -borderwidth 2 \
         -font $medium_font -text "00.0"
    place .ftop.gps31 -relx $gpsRelX -x 10 -rely $gpsRelY -y 25 -anchor nw

    # baseline summary
    set baseRelX 0.86 
    set baseRelY 0.37 
    label .ftop.pLbl -text "POS" -font $medium_font
    place .ftop.pLbl -relx $baseRelX -x 10 -rely $baseRelY -y -25 -anchor ne
    label .ftop.a1Lbl -text "ATT" -font $medium_font
    place .ftop.a1Lbl -relx $baseRelX -x 70 -rely $baseRelY -y -25 -anchor ne
    
    label .ftop.dopLbl -text "DOP" -font $medium_font
    place .ftop.dopLbl -relx $baseRelX -x -50 -rely $baseRelY -y 0 -anchor ne
    label .ftop.svUsedLbl -text "Sats Used" -font $medium_font
    place .ftop.svUsedLbl -relx $baseRelX -x -50 -rely $baseRelY -y 25 \
                         -anchor ne

    label .ftop.base11 -width 6 -relief sunken -borderwidth 2 \
         -font $medium_font 
    place .ftop.base11 -relx $baseRelX -x 20 -rely $baseRelY -y 0 -anchor ne
    label .ftop.base12 -width 6 -relief sunken -borderwidth 2 \
         -font $medium_font 
    place .ftop.base12 -relx $baseRelX -x 80 -rely $baseRelY -y 0 -anchor ne
    
    label .ftop.base21 -width 6 -relief sunken -borderwidth 2 \
         -font $medium_font 
    place .ftop.base21 -relx $baseRelX -x 20 -rely $baseRelY -y 25 -anchor ne
    label .ftop.base22 -width 6 -relief sunken -borderwidth 2 \
         -font $medium_font 
    place .ftop.base22 -relx $baseRelX -x 80 -rely $baseRelY -y 25 -anchor ne

    # gps quality/accuracy summary
    set qualRelX 0.79 
    set qualRelY 0.59 
    label .ftop.qualLbl -text "Quality" -font $medium_font
    place .ftop.qualLbl -relx $qualRelX -x -5 -rely $qualRelY -y 0 -anchor ne
    label .ftop.accLbl -text "Accuracy" -font $medium_font
    place .ftop.accLbl -relx $qualRelX -x -5 -rely $qualRelY -y 25 -anchor ne

    label .ftop.qual11 -width 13 -relief sunken -borderwidth 2 \
         -font $medium_font 
    place .ftop.qual11 -relx $qualRelX -x 12 -rely $qualRelY -y 0 -anchor nw
    label .ftop.qual21 -width 13 -relief sunken -borderwidth 2 \
         -font $medium_font 
    place .ftop.qual21 -relx $qualRelX -x 12 -rely $qualRelY -y 25 -anchor nw

    # buttons
    SnazzyButton::create .ftop.gpsLog btnBlueM5U btnBlueM5D 0.2 \
            "beepOnce; post $DISP_BTN1_SIG 1" "GPS Log"
    place .ftop.gpsLog -x 0 -rely 1.0 -y -125 -anchor sw            
    SnazzyButton::create .ftop.return btnKhakiU btnKhakiD 0.2 \
           "beepOnce; post $DISP_BTN9_SIG 9"
    place .ftop.return -x 0 -rely 1.0 -y -10 -anchor sw            

    # GPS signal strength barchart canvas
    set numbars 48
    set numdatalinkbars 16
    set bar_x   528
    set track_h 107
    set maxwinx 480
    set maxwiny 125
    set bar_y   [expr $track_h-25]
    set datalinkbar_y [expr $bar_y-10]
    set bar_w   [expr $bar_x/$numbars]
    
    label .ftop.barchart2Lbl -text "GPS Signal Strength: " -font $medium_font
    place .ftop.barchart2Lbl -relx 0.35 -x 77 -rely 0.64 -y 25 -anchor ne
    canvas .ftop.c -height $track_h -width [expr $bar_x+1] \
           -relief sunken -borderwidth 1
    place .ftop.c -x 115 -rely 1.0 -y -10 -anchor sw
           
    for {set ind 1} {$ind <= $numbars} {incr ind} {
        .ftop.c create line 0 0 0 0 -width 1 -fill yellow3 -tag sep$ind
        .ftop.c create line 0 0 0 0 -width [expr $bar_w] -fill blue -tag bar$ind
        .ftop.c create line 0 0 0 0 -width 6 -tag bartwo$ind -fill grey
        .ftop.c create text \
              [expr ($bar_w)*($ind-1)] \
              [expr $bar_y + 15 + ($ind/2.0 -floor($ind/2.0))*0 - 5] \
              -anchor w -text " " -tag barlbl$ind -font {times 1}
        .ftop.c create text \
              [expr ($bar_w)*($ind-1)] \
              [expr $bar_y + 30 - 10] \
              -anchor w -text " " -tag elevlbl$ind -font {times 1}
    }
    .ftop.c create rectangle 1 $bar_y [expr $bar_x+2] 1 -outline black
    .ftop.c create line 1 [expr $bar_y*3.0/4.0] [expr $bar_x+2] \
                               [expr $bar_y*3.0/4.0]
    .ftop.c create line 1 [expr $bar_y/2.0] [expr $bar_x+2] [expr $bar_y/2.0]
    .ftop.c create line 1 [expr $bar_y/4.0] [expr $bar_x+2] [expr $bar_y/4.0]

    # Data link signal strength barchart canvas
    label .ftop.barchart1Lbl -text "Correction Signal Strength: " \
                             -font $medium_font
    place .ftop.barchart1Lbl -relx 0.35 -x 118 -rely 0.55 -y -30 -anchor ne

    label .ftop.percentreceived -text "Percent Packet\nReceived:" \
                             -font $small_font 
    place .ftop.percentreceived -relx 0.36 -x -2 -rely 0.56 -y -5 -anchor ne
 
    label .ftop.io41 -text "NA" -font $medium_font 
    place .ftop.io41 -relx 0.35 -x -30 -rely 0.56 -y 30 -anchor ne
    
    canvas .ftop.c1 -height $datalinkbar_y -width [expr $bar_x/3] \
           -relief sunken -borderwidth 1
    place .ftop.c1 -relx 0.55 -x -128 -rely 0.32 -y 95 -anchor nw

    for {set ind 1} {$ind <= $numdatalinkbars} {incr ind} {
      .ftop.c1 create line 0 0 0 0 -width $bar_w -fill grey \
                                   -tag datalinkbar$ind
      .ftop.c1 create text [expr $bar_w*$ind-3] [expr $datalinkbar_y-5] \
                             -text "" -font {times 10} -tag datalinklbl$ind
    }

    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    
    proc actEntry { returnBtn gpsLogBtn accLbl qualLbl 
		    link cab1 cab2 cab3 serial base dist2base 
		    vlat vlon valt dop svused gpssnr 
		    correctionsnr packets } {
        .ftop.return configure -text $returnBtn
        .ftop.gpsLog configure -text $gpsLogBtn
        .ftop.accLbl configure -text $accLbl
        .ftop.qualLbl configure -text $qualLbl
	.ftop.linkLbl configure -text $link
	.ftop.serialLbl configure -text $serial
	.ftop.cab1Lbl configure -text $cab1
	.ftop.cab2Lbl configure -text $cab2
	.ftop.baseLbl configure -text $base
	.ftop.baseDistTxt configure -text $dist2base
	.ftop.latLbl configure -text $vlat
	.ftop.lonLbl configure -text $vlon
	.ftop.altLbl configure -text $valt
	.ftop.dopLbl configure -text $dop
	.ftop.svUsedLbl configure -text $svused
	.ftop.barchart2Lbl configure -text $gpssnr
	.ftop.barchart1Lbl configure -text $correctionsnr
	.ftop.percentreceived configure -text $packets
        pack .ftop -fill both -expand yes
    }

    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }

    #-------------------------------------------------------------------------
    # other action procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    proc actSetColor {ind color} {
        .ftop.c itemconfigure bar$ind -fill $color
        .ftop.c itemconfigure barlbl$ind -fill $color
    }

    proc actSetColor2 {ind color} {
        .ftop.c itemconfigure bartwo$ind -fill $color
#        .ftop.c itemconfigure bartwo$ind -fill yellow2
    }

    proc actSetLabel {ind label} {
        .ftop.c itemconfigure barlbl$ind -text $label
        .ftop.c itemconfigure barlbl$ind -font {times 10}
    }

    proc actSetElev {ind label} {
        .ftop.c itemconfigure elevlbl$ind -text $label
        .ftop.c itemconfigure elevlbl$ind -font {times 10}
    }

    proc actSetBar {ind frac} {
        global Screen::bar_w 
        global Screen::bar_y
        global Screen::numbars
        set x [expr $ind*$bar_w-4]
        .ftop.c coords bar$ind $x $bar_y \
            $x [expr $Screen::bar_y - $Screen::bar_y*$frac]
    }

    proc actUpdateDataLinkBar {f1 f2 f3 f4 f5 f6 f7 f8 f9 f10 f11 f12 f13 \
                                   f14 f15 f16 f17 f18 f19 f20 f21 f22 f23 f24 \
                                   f25 f26 f27 f28 f29 f30 f31 f32} {
        global Screen::bar_w 
        global Screen::datalinkbar_y
        global Screen::numdatalinkbars
        

        foreach ind {1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16} {
            set ff f$ind
            set ff2 f[expr $ind+16]
            set db datalinkbar$ind
            set dl datalinklbl$ind
            set x [expr $ind*$Screen::bar_w-4]
            .ftop.c1 coords $db $x $Screen::datalinkbar_y \
                $x [expr $Screen::datalinkbar_y - $Screen::datalinkbar_y*[expr $$ff]+2]
            set str1 [expr 10*[expr $$ff]]
            .ftop.c1 itemconfigure $dl -text [string range $str1 0 0]
            if {[string length $str1] == 4} {
                .ftop.c1 itemconfigure $dl -text [string range $str1 0 1]
            }
            if {[expr $$ff2] > "0.8"} {
                .ftop.c1 itemconfigure $db -fill green
            }
            if {[expr $$ff2] < "0.9"} {
                .ftop.c1 itemconfigure $db -fill yellow
            }
            if {[expr $$ff2] < "0.5"} {
                .ftop.c1 itemconfigure $db -fill red
            }
        }
    }

    proc actConfigPercent { frac } {
        .ftop.io41 configure -text $frac
        # [expr 100*$frac]
    }
    
    proc actSetBar2 {ind frac} {
        global Screen::bar_w 
        global Screen::bar_y
        global Screen::numbars
#        set x1 [expr $ind*$bar_w-6]
#        set x2 [expr $ind*$bar_w-2]
        set x [expr $ind*$bar_w-1]
        .ftop.c coords bartwo$ind $x $bar_y \
            $x [expr $Screen::bar_y - $Screen::bar_y*$frac]
    }

    proc actSetSep {ind} {
        global Screen::track_h
        global Screen::bar_w 
        global Screen::bar_y
        set x [expr $ind*$bar_w-9]
        .ftop.c coords sep$ind $x $track_h \
            $x [expr $Screen::bar_y - $Screen::bar_y]
    }
   
    proc actSetIoCell { i j val {col lightgrey} } {
		if {$i == 1 || $i == 2 || $i == 3} {
          .ftop.io$i$j configure -text $val
          .ftop.io$i$j configure -background $col
		}
		if {$i == 4} {
		  set k [expr $i-1]
          .ftop.io$k$j configure -text $val
          .ftop.io$k$j configure -background $col
		}
    }

    proc actSetIoCellCol { i j col} {
	    if {$i == 1 || $i == 2} {
          .ftop.io$i$j configure -background $col
		}
	    if {$i == 4} {
		  set k [expr $i-1]
          .ftop.io$k$j configure -background $col
		}
    }
   
    proc actSetBaseCell { i j val } {
        .ftop.base$i$j configure -text $val
    }

    proc actSetGpsCell { i j val } {
        .ftop.gps$i$j configure -text $val
    }
    
    proc actSetAlt { val } {
        .ftop.gps31 configure -text $val
    }

    proc actConfigLinkLight { i j } {
        if {$i == 4} {
          set i 3
        }
        if {$i < 4} {
          .ftop.io$i$j configure -image btnGREEN
        }
    }
    
    proc actConfigLinkLightRed { i j } {
        if {$i == 4} {
          set i 3
        }
        if {$i < 4} {
          .ftop.io$i$j configure -image btnRED
        }    
    }

    proc actSetQualCell { i j val {col lightgrey}} {
        .ftop.qual$i$j configure -text $val
        .ftop.qual$i$j configure -background $col
    }
    
    proc actSetBaseDist { baseLbl dist } {
        .ftop.baseDistTxt configure -text $baseLbl
        .ftop.baseDist configure -text $dist
    }
}
