##############################################################################
#
# vc/src/tcl/helpscreen.tcl
#
# A modal-dialog-type helpscreen.
#
# 20020625 MLE - created
#
# Copyright (c) 2002 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval MainImplementHelp { 
    frame .mainImplementHelp
    frame .mainImplementHelp.head
    frame .mainImplementHelp.head.top
    frame .mainImplementHelp.head.center
    frame .mainImplementHelp.head.bottom
    frame .mainImplementHelp.table
    frame .mainImplementHelp.table.left
    frame .mainImplementHelp.table.center
    frame .mainImplementHelp.table.right

    
    pack .mainImplementHelp.head.top -side top -expand yes -fill x
    pack .mainImplementHelp.head.center -side top -expand yes -fill x
    pack .mainImplementHelp.head.bottom -side top -expand yes -fill x
    pack .mainImplementHelp.head -side top -expand yes -fill x

    pack .mainImplementHelp.table.left -side left -expand yes -fill x
    pack .mainImplementHelp.table.center -side left -expand yes -fill x
    pack .mainImplementHelp.table.right -side left -expand yes -fill x
    pack  .mainImplementHelp.table -side top -expand yes -fill x

    image create photo btnKhakiU -format gif -file \
	${tclPath}gif/btnKhakiU.gif
    image create photo btnKhakiD -format gif -file \
	${tclPath}gif/btnKhakiD.gif
    image create photo bar -format gif -file \
	${tclPath}gif/bar.gif

    label .mainImplementHelp.head.top.title1 -text "Help" -font $huge_font -justify center
    label .mainImplementHelp.head.top.title2 -text "Synchronize User Data" -font $big_font -justify center

    pack .mainImplementHelp.head.top.title1 -side top
    pack .mainImplementHelp.head.top.title2 -side top

    label .mainImplementHelp.head.top.intro1 -text \
	"The sync disk program compares the Base Station, Field, Job, Implement and \
Vehicle entries\n on your CF disk and GPS System. The table below\
shows the action that will be performed\n\
when comparing the data." \
    -font $small_font -justify left
    pack .mainImplementHelp.head.top.intro1 -side top

    label .mainImplementHelp.head.top.header0 -text "Synchronization Program Action" -font $big_font
    pack .mainImplementHelp.head.top.header0 -side top

    label .mainImplementHelp.head.center.header1 -text "Case" -font $big_font
    pack .mainImplementHelp.head.center.header1 -side left

    label .mainImplementHelp.head.center.header2 -text "Automatic Mode" -font $big_font
    label .mainImplementHelp.head.center.header3 -text "Manual Mode" -font $big_font
    pack .mainImplementHelp.head.center.header3 -side right -padx 15
    pack .mainImplementHelp.head.center.header2 -side right -padx 15

    label .mainImplementHelp.head.bottom.bar -image bar
    pack .mainImplementHelp.head.bottom.bar -side bottom -anchor w

    label .mainImplementHelp.table.left.case1 -text "1. Entry exists on CF Disk and on GPS System:\n \
                        same name, same data." -font $small_font -justify left
    label .mainImplementHelp.table.center.auto1 -text "Does Nothing." -font $small_font
    label .mainImplementHelp.table.right.manual1 -text "Does Nothing." -font $small_font
    pack .mainImplementHelp.table.left.case1 -side top -anchor w
    pack .mainImplementHelp.table.right.manual1 -side top -anchor nw -padx 15
    pack .mainImplementHelp.table.center.auto1 -side top -anchor nw -padx 15

    label .mainImplementHelp.table.left.case2 -text "2. Entry exists on CF Disk and on GPS System:\n \
                        same name, different data." -font $small_font -justify left
    label .mainImplementHelp.table.center.auto2 -text "Asks User." -font $small_font
    label .mainImplementHelp.table.right.manual2 -text "Asks User." -font $small_font
    pack .mainImplementHelp.table.left.case2 -side top -anchor nw
    pack .mainImplementHelp.table.right.manual2 -side top -padx 15 -anchor nw
    pack .mainImplementHelp.table.center.auto2 -side top -anchor nw -padx 15

    label .mainImplementHelp.table.left.case3 -text "3. Entry exists only on CF Disk." \
	-font $small_font -justify left
    label .mainImplementHelp.table.center.auto3 -text "Copies to GPS System." -font $small_font
    label .mainImplementHelp.table.right.manual3 -text "Asks User." -font $small_font
    pack .mainImplementHelp.table.left.case3 -side top -anchor nw
    pack .mainImplementHelp.table.right.manual3 -side top -padx 15 -anchor nw
    pack .mainImplementHelp.table.center.auto3 -side top -anchor nw -padx 15

    label .mainImplementHelp.table.left.case4 -text "4. Entry exists only on GPS System." \
	-font $small_font -justify left
    label .mainImplementHelp.table.center.auto4 -text "Copies to CF Disk." -font $small_font
    label .mainImplementHelp.table.right.manual4 -text "Asks User." -font $small_font
    pack .mainImplementHelp.table.left.case4 -side top -anchor nw
    pack .mainImplementHelp.table.right.manual4 -side top -padx 15 -anchor nw
    pack .mainImplementHelp.table.center.auto4 -side top -anchor nw -padx 15


    proc actSetStrings { t1 t2 i1 h0 h1 h2 h3 \
			     c1 a1 m1 \
			     c2 a2 m2 \
			     c3 a3 m3 \
			     c4 a4 m4 } {
	.mainImplementHelp.head.top.title1 configure -text $t1
	.mainImplementHelp.head.top.title2 configure -text $t2
	.mainImplementHelp.head.top.intro1 configure -text $i1
	.mainImplementHelp.head.top.header0 configure -text $h0
	.mainImplementHelp.head.center.header1 configure -text $h1
	.mainImplementHelp.head.center.header2 configure -text $h2
	.mainImplementHelp.head.center.header3 configure -text $h3

	.mainImplementHelp.table.left.case1 configure -text $c1
	.mainImplementHelp.table.center.auto1 configure -text $a1
	.mainImplementHelp.table.right.manual1 configure -text $m1

	.mainImplementHelp.table.left.case2 configure -text $c2
	.mainImplementHelp.table.center.auto2 configure -text $a2
	.mainImplementHelp.table.right.manual2 configure -text $m2

	.mainImplementHelp.table.left.case3 configure -text $c3
	.mainImplementHelp.table.center.auto3 configure -text $a3
	.mainImplementHelp.table.right.manual3 configure -text $m3

	.mainImplementHelp.table.left.case4 configure -text $c4
	.mainImplementHelp.table.center.auto4 configure -text $a4
	.mainImplementHelp.table.right.manual4 configure -text $m4
    }

    proc Exit { } {
	destroy .mainImplementHelp
    }
}
