##############################################################################
#
# vc/src/tcl/waitForVirtualBase.tcl
#
# Screen to initialize non-RTK modes.
#
# 20060831 RCM - created
#
# Copyright (c) 2006 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Modal { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .fmodal and destroy it on exit
    frame .fmodal

    # Define and pack the screen layout

    # Title
    frame .fmodal.title
    label .fmodal.title.titleTxt -text "Space for title"
    label .fmodal.title.subTitleTxt -text "Space for sub title" \
      -font medium_font
    
    # Divider between title and content
    label .fmodal.title.divider -image imgDivider
    
    # Main waitForVirtualBase Content frame
    frame .fmodal.content
    
    # stepOneWaitForVirtualBase Content frame
    frame .fmodal.content.stepone
    frame .fmodal.content.stepone.nmea
    frame .fmodal.content.stepone.ports
    
    # waasEgnosWaitForVirtualBase Content frame
    frame .fmodal.content.waas
    frame .fmodal.content.waas.config
    frame .fmodal.content.waas.status
    
    # omniStarWaitForVirtualBase Content frame
    frame .fmodal.content.omnistar
    
    # Subscription Status
    #-------------------------------------------------------------------------
    frame .fmodal.content.omnistar.subscription -bd 1 -relief solid 
    frame .fmodal.content.omnistar.subscription.row1
    frame .fmodal.content.omnistar.subscription.row1.col1
    frame .fmodal.content.omnistar.subscription.row1.col2
    frame .fmodal.content.omnistar.subscription.row2
    frame .fmodal.content.omnistar.subscription.row2.col1
    frame .fmodal.content.omnistar.subscription.row2.col2
    frame .fmodal.content.omnistar.subscription.row3
    frame .fmodal.content.omnistar.subscription.row3.col1
    frame .fmodal.content.omnistar.subscription.row3.col2
    frame .fmodal.content.omnistar.subscription.row4
    frame .fmodal.content.omnistar.subscription.row4.col1
    frame .fmodal.content.omnistar.subscription.row4.col2
    frame .fmodal.content.omnistar.subscription.row5
    frame .fmodal.content.omnistar.subscription.row5.col1
    frame .fmodal.content.omnistar.subscription.row5.col2
    frame .fmodal.content.omnistar.subscription.spacer -height 10  
    label .fmodal.content.omnistar.subscription.titleTxt -bd 1 -relief solid \
      -bg lightgray
    label .fmodal.content.omnistar.subscription.row1.col1.startTimeTxt
    label .fmodal.content.omnistar.subscription.row1.col2.startTime -bd 1 \
      -relief sunken -width 14 -text "0" -font $medium_font
    label .fmodal.content.omnistar.subscription.row2.col1.expirationTimeTxt
    label .fmodal.content.omnistar.subscription.row2.col2.expirationTime -bd 1 \
      -relief sunken -width 14 -text "0" -font $medium_font
    label .fmodal.content.omnistar.subscription.row3.col1.monthRemainingTxt
    label .fmodal.content.omnistar.subscription.row3.col2.monthRemaining -bd 1 \
      -relief sunken -width 14 -text "0" -font $medium_font
    label .fmodal.content.omnistar.subscription.row4.col1.dayRemainingTxt
    label .fmodal.content.omnistar.subscription.row4.col2.dayRemaining -bd 1 \
      -relief sunken -width 14 -text "0" -font $medium_font
    label .fmodal.content.omnistar.subscription.row5.col1.serialNumTxt
    label .fmodal.content.omnistar.subscription.row5.col2.serialNum -bd 1 \
      -relief sunken -width 14 -text "000000" -font $medium_font
    
    # Configuration Status
    #-------------------------------------------------------------------------
    frame .fmodal.content.omnistar.config -bd 1 -relief solid 
    frame .fmodal.content.omnistar.config.row1
    frame .fmodal.content.omnistar.config.row1.col1
    frame .fmodal.content.omnistar.config.row1.col2
    frame .fmodal.content.omnistar.config.row2
    frame .fmodal.content.omnistar.config.row2.col1
    frame .fmodal.content.omnistar.config.row2.col2
    frame .fmodal.content.omnistar.config.row3
    frame .fmodal.content.omnistar.config.row3.col1
    frame .fmodal.content.omnistar.config.row3.col2
    frame .fmodal.content.omnistar.config.row4
    frame .fmodal.content.omnistar.config.row4.col1
    frame .fmodal.content.omnistar.config.row4.col2  
    frame .fmodal.content.omnistar.config.spacer -height 10
    label .fmodal.content.omnistar.config.titleTxt -bd 1 -relief solid \
      -bg lightgray
    label .fmodal.content.omnistar.config.row1.col1.idLblTxt -bd 1
    label .fmodal.content.omnistar.config.row1.col2.id -bd 1 \
      -relief sunken -width 13
    label .fmodal.content.omnistar.config.row2.col1.nameLblTxt
    label .fmodal.content.omnistar.config.row2.col2.name -bd 1 \
      -relief sunken -width 13
    label .fmodal.content.omnistar.config.row3.col1.freqLblTxt
    label .fmodal.content.omnistar.config.row3.col2.freq -bd 1 \
      -relief sunken -width 13
    
    # Position Status
    #-------------------------------------------------------------------------
    frame .fmodal.content.omnistar.position -bd 1 -relief solid
    frame .fmodal.content.omnistar.position.spacer -height 10
    frame .fmodal.content.omnistar.position.status
    frame .fmodal.content.omnistar.position.status.text
    frame .fmodal.content.omnistar.position.status.indicator
    label .fmodal.content.omnistar.position.titleTxt -bd 1 -relief solid \
      -bg lightgray
    label .fmodal.content.omnistar.position.status.text.posStatusTxt \
      -text "Waiting..." -font $medium_font 
    label .fmodal.content.omnistar.position.status.indicator.posStatus -image btnGREY 
    label .fmodal.content.omnistar.position.percentComplete -text "Percent Complete" \
      -font $medium_font
    label .fmodal.content.omnistar.position.accuracyLevel -text "Accuracy Level" \
      -font $medium_font
    
    set barWidth 130
    set barHeight 20
    canvas .fmodal.content.omnistar.position.bar -background $color6 \
            -width $barWidth -height $barHeight -relief sunken -borderwidth 2
    incr barHeight        
    .fmodal.content.omnistar.position.bar create rectangle 0 0 0 $barHeight \
            -outline black -fill $colorMedium -tags gauge
    .fmodal.content.omnistar.position.bar create text [expr $barWidth/2] 4 \
            -font $small_font -anchor nw -text "0%" -tags value
    
    # Button frame
    frame .fmodal.buttons
    SnazzyButton::create .fmodal.buttons.skip btnBlueU btnBlueD 0.5 \
                 "beepOnce; post $DISP_BTN0_SIG 0;" "Skip to\nMain Menu"
    SnazzyButton::create .fmodal.buttons.config btnBlueU btnBlueD 0.5 \
                 "beepOnce; post $DISP_BTN1_SIG 1;" "Configure"
    SnazzyButton::create .fmodal.buttons.return btnKhakiU btnKhakiD 0.2 \
                 "beepOnce; post $DISP_BTN9_SIG 9;" "Return To\nPrevious\nMenu"
                 
    # Exit button
    SnazzyButton::create .fmodal.buttons.exit btnExitKhakiU btnExitKhakiD 0.5 \
            "beepOnce; guiExit" "Exit"
                
    # pack waitForVirtualBase buttons     
    pack .fmodal.buttons.config -side right -padx 5 -pady 5 -anchor se 

    # Pack .fmodal
    pack .fmodal.title -side top -fill x -anchor n
    pack .fmodal.title.titleTxt -side top -fill x -pady 5
    pack .fmodal.title.divider -side top -anchor n
    pack .fmodal.title.subTitleTxt -side top -fill x
    pack .fmodal.content -side top -fill both -expand yes -anchor n -pady 10
    pack .fmodal.buttons -side bottom -anchor se -fill both -expand yes
                
    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry {} {    
        pack forget .ftop
        pack .fmodal -fill both -expand yes
    }

    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .fmodal
        pack .ftop -fill both -expand yes
    }

    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------

    proc actSetAccuracyLevel { text accLvl } {
      if {$accLvl == 1.0} {
        .fmodal.content.omnistar.position.accuracyLevel configure -text "$text:\n\n 40in/100cm"
      }
      if {$accLvl == 0.50} {
        .fmodal.content.omnistar.position.accuracyLevel configure -text "$text:\n\n 20in/50cm"
      }
      if {$accLvl == 0.30} {
        .fmodal.content.omnistar.position.accuracyLevel configure -text "$text:\n\n 12in/30cm"
      }
      if {$accLvl == 0.15} {
        .fmodal.content.omnistar.position.accuracyLevel configure -text "$text:\n\n 6in/15cm"
      } 
    }
	
    proc actConfigure { exitBtn returnBtn skipBtn titleTxt_ subTitleTxt_ \
                        configBtnTxt_ subscriptTxt_ configTxt_ positionTxt_} {
      
      global big_font medium_font 
      
      if {$exitBtn != "!"} {
        pack .fmodal.buttons.exit -side left -padx 5 -pady 5 -anchor sw
        SnazzyButton::setText .fmodal.buttons.exit $exitBtn 0.2
      }
      if {$skipBtn != "!"} {
        pack .fmodal.buttons.skip -side right -padx 5 -pady 5 -anchor se
        SnazzyButton::setText .fmodal.buttons.skip $skipBtn 0.5
      }
      if {$returnBtn != "!"} {
        pack .fmodal.buttons.return -side left -padx 5 -pady 5 -anchor sw
        SnazzyButton::setText .fmodal.buttons.return $returnBtn 0.5
      }
      
      .fmodal.title.titleTxt configure -text $titleTxt_
      .fmodal.title.subTitleTxt configure -text $subTitleTxt_ \
        -font $medium_font
      .fmodal.buttons.config configure -text $configBtnTxt_
      .fmodal.content.omnistar.subscription.titleTxt configure \
        -text $subscriptTxt_ -font $big_font 
      .fmodal.content.omnistar.config.titleTxt configure \
        -text $configTxt_ -font $big_font
      .fmodal.content.omnistar.position.titleTxt configure \
        -text $positionTxt_ -font $big_font  
      
      
      # Pack OmniSTAR Position Status
      #-----------------------------------------------------------------------
      pack .fmodal.content.omnistar.position.titleTxt -side top -fill x
      pack .fmodal.content.omnistar.position.spacer -side top
      
      pack .fmodal.content.omnistar.position.status.text.posStatusTxt -side left -padx 2
      pack .fmodal.content.omnistar.position.status.indicator.posStatus -side left -padx 5
      pack .fmodal.content.omnistar.position.status.text -side left -padx 12
      pack .fmodal.content.omnistar.position.status.indicator -side left
      pack .fmodal.content.omnistar.position.status -side top -fill x -anchor nw
      pack .fmodal.content.omnistar.position.percentComplete -side top -pady 5 \
        -anchor nw -fill x
      pack .fmodal.content.omnistar.position.bar -side top -anchor n -padx 1
      pack .fmodal.content.omnistar.position.accuracyLevel -side top -pady 5 \
        -anchor nw -fill x
      
      pack .fmodal.content.omnistar.position -side left -anchor nw \
        -padx 5 -fill both -expand yes
      
      # Pack OmniSTAR Subscription Status
      #-----------------------------------------------------------------------
      pack .fmodal.content.omnistar.subscription.titleTxt -side top -fill x
      pack .fmodal.content.omnistar.subscription.spacer -side top -fill x
      #pack .fmodal.content.omnistar.subscription.row1.col1.startTimeTxt -side left \
      #  -anchor w 
      #pack .fmodal.content.omnistar.subscription.row1.col2.startTime -side left \
      #  -anchor w -padx 3
      pack .fmodal.content.omnistar.subscription.row2.col1.expirationTimeTxt \
        -side left -anchor w
      pack .fmodal.content.omnistar.subscription.row2.col2.expirationTime \
        -side left -anchor w -padx 3
      pack .fmodal.content.omnistar.subscription.row3.col1.monthRemainingTxt -side left \
        -anchor w
      pack .fmodal.content.omnistar.subscription.row3.col2.monthRemaining -side left \
        -anchor w -padx 3
      pack .fmodal.content.omnistar.subscription.row4.col1.dayRemainingTxt -side left \
        -anchor w
      pack .fmodal.content.omnistar.subscription.row4.col2.dayRemaining -side left \
        -anchor w -padx 3
      pack .fmodal.content.omnistar.subscription.row5.col1.serialNumTxt -side left \
        -anchor w
      pack .fmodal.content.omnistar.subscription.row5.col2.serialNum -side left \
        -anchor w -padx 3
      pack .fmodal.content.omnistar.subscription.row1.col1 -side left -anchor nw
      pack .fmodal.content.omnistar.subscription.row1.col2 -side right -anchor ne
      pack .fmodal.content.omnistar.subscription.row2.col1 -side left -anchor nw
      pack .fmodal.content.omnistar.subscription.row2.col2 -side right -anchor ne
      pack .fmodal.content.omnistar.subscription.row3.col1 -side left -anchor nw
      pack .fmodal.content.omnistar.subscription.row3.col2 -side right -anchor ne
      pack .fmodal.content.omnistar.subscription.row4.col1 -side left -anchor nw
      pack .fmodal.content.omnistar.subscription.row4.col2 -side right -anchor ne
      pack .fmodal.content.omnistar.subscription.row5.col1 -side left -anchor nw
      pack .fmodal.content.omnistar.subscription.row5.col2 -side right -anchor ne

      pack .fmodal.content.omnistar.subscription.row1 -side top -anchor n \
        -pady 2 -fill x
      pack .fmodal.content.omnistar.subscription.row2 -side top -anchor n \
        -pady 2 -fill x
      #pack .fmodal.content.omnistar.subscription.row3 -side top -anchor n \
      #  -pady 2 -fill x
      #pack .fmodal.content.omnistar.subscription.row4 -side top -anchor n \
      #  -pady 2 -fill x
      pack .fmodal.content.omnistar.subscription.row5 -side top -anchor n \
        -pady 2 -fill x
      pack .fmodal.content.omnistar.subscription -side left -anchor nw \
        -padx 5 -fill both -expand yes
        
      
      # Pack OmniSTAR Configuration
      #-----------------------------------------------------------------------
      pack .fmodal.content.omnistar.config.titleTxt -side top -fill x
      pack .fmodal.content.omnistar.config.spacer -side top -fill x
      pack .fmodal.content.omnistar.config.row1.col1.idLblTxt -side left -anchor nw
      pack .fmodal.content.omnistar.config.row1.col2.id -side left -padx 3
      pack .fmodal.content.omnistar.config.row2.col1.nameLblTxt -side left 
      pack .fmodal.content.omnistar.config.row2.col2.name -side left -padx 3
      pack .fmodal.content.omnistar.config.row3.col1.freqLblTxt -side left 
      pack .fmodal.content.omnistar.config.row3.col2.freq -side left -padx 3
      pack .fmodal.content.omnistar.config.row1.col1 -side left -anchor nw
      pack .fmodal.content.omnistar.config.row1.col2 -side right -anchor nw
      pack .fmodal.content.omnistar.config.row2.col1 -side left -anchor nw
      pack .fmodal.content.omnistar.config.row2.col2 -side right -anchor nw
      pack .fmodal.content.omnistar.config.row3.col1 -side left -anchor nw
      pack .fmodal.content.omnistar.config.row3.col2 -side right -anchor nw
      
      pack .fmodal.content.omnistar.config.row1 -side top -anchor n \
        -pady 2 -fill x
      pack .fmodal.content.omnistar.config.row2 -side top -anchor n \
        -pady 2 -fill x
      pack .fmodal.content.omnistar.config.row3 -side top -anchor n \
        -pady 2 -fill x
      
      pack .fmodal.content.omnistar.config -side left -anchor nw \
        -padx 5 -fill both -expand yes
      
      # Pack OmniSTAR Content
      #-----------------------------------------------------------------------
      pack .fmodal.content.omnistar -side top -expand yes -fill both
    
    }

    #-------------------------------------------------------------------------
    # OmniStar Specific Display Actions (called by waitForVirtualBase)
    #-------------------------------------------------------------------------
    proc actDisplaySubscriptionStatus {startTimeLblTxt__  \
                                       expirationTimeLblTxt__ \
                                       timeRemainingLblTxt__} {
       global medium_font
       
       # Display Subscriptiuon Status                                
      .fmodal.content.omnistar.subscription.row1.col1.startTimeTxt configure \
        -text $startTimeLblTxt__ -font $medium_font
      .fmodal.content.omnistar.subscription.row2.col1.expirationTimeTxt configure \
        -text $expirationTimeLblTxt__ -font $medium_font
      .fmodal.content.omnistar.subscription.row3.col1.monthRemainingTxt configure \
        -text $timeRemainingLblTxt__ -font $medium_font
      .fmodal.content.omnistar.subscription.row4.col1.dayRemainingTxt configure \
        -text "  " -font $medium_font
        
    }
    
    proc actDisplaySubscription {startTime__ expirationTime__ monthRemaining__ \
                                 dayRemaining__} {
      global medium_font
      .fmodal.content.omnistar.subscription.row1.col2.startTime configure \
        -text $startTime__ -font $medium_font -justify left
      .fmodal.content.omnistar.subscription.row2.col2.expirationTime configure \
        -text $expirationTime__ -font $medium_font -justify left
      .fmodal.content.omnistar.subscription.row3.col2.monthRemaining configure \
        -text $monthRemaining__ -font $medium_font -justify left
      .fmodal.content.omnistar.subscription.row4.col2.dayRemaining configure \
        -text $dayRemaining__ -font $medium_font -justify left  
    }
     
    proc actDisplaySerialNumber {serialNumTxt__ serialNum__} {
      global medium_font
      
      .fmodal.content.omnistar.subscription.row5.col1.serialNumTxt configure \
        -text $serialNumTxt__ -font $medium_font
      .fmodal.content.omnistar.subscription.row5.col2.serialNum configure \
        -text $serialNum__ -font $medium_font -justify left
    }
    
    proc actDisplayConfigurationStatus {idLblTxt__ id__  \
                                        nameLblTxt__ name__\
                                        freqLblTxt__ freq__} {
      global medium_font
      
      # Display Configuration Status
      .fmodal.content.omnistar.config.row1.col1.idLblTxt configure \
        -text $idLblTxt__ -font $medium_font
      .fmodal.content.omnistar.config.row1.col2.id configure \
        -text $id__ -font $medium_font
      .fmodal.content.omnistar.config.row2.col1.nameLblTxt configure \
        -text $nameLblTxt__ -font $medium_font
      .fmodal.content.omnistar.config.row2.col2.name configure \
        -text $name__ -font $medium_font
      .fmodal.content.omnistar.config.row3.col1.freqLblTxt configure \
        -text $freqLblTxt__ -font $medium_font
      .fmodal.content.omnistar.config.row3.col2.freq configure \
        -text $freq__ -font $medium_font
    }
    
    proc actPosPercent { percentComplete } {
      global colorGood
      .fmodal.content.omnistar.position.bar itemconfigure gauge \
        -fill $colorGood
      .fmodal.content.omnistar.position.bar itemconfigure value \
        -text "$percentComplete%"

      # MLE-040301: Tcl doing math!! Not allowed; fix this...
      .fmodal.content.omnistar.position.bar coords gauge 1 1 \
        [expr 0.0100*$percentComplete*$Modal::barWidth] $Modal::barHeight
    }
    
    proc actDisplayPosStatusText { posStatusText__ } {
      global medium_font
      .fmodal.content.omnistar.position.status.text.posStatusTxt configure \
        -text $posStatusText__  
    }
    
    proc actSetPosStatusRed { } {
      .fmodal.content.omnistar.position.status.indicator.posStatus configure -image btnRED
    }
    
    proc actSetPosStatusYellow { } {
      .fmodal.content.omnistar.position.status.indicator.posStatus configure -image btnYELLOW
    }
    
    proc actSetPosStatusGreen { } {
      .fmodal.content.omnistar.position.status.indicator.posStatus configure -image btnGREEN
    }
    
    proc actSetPosStatusClear { } {
      .fmodal.content.omnistar.position.status.indicator.posStatus configure -image btnGREY
    }

    #-------------------------------------------------------------------------
    # Delegated procedures
    #-------------------------------------------------------------------------

    #-------------------------------------------------------------------------
    # Local procedures
    # {MLE-020418: Tcl/Tk goal should be to get rid of all local procedures, 
    # because they represent intelligence, which the display should not have.}
    #-------------------------------------------------------------------------
    # Local procedures
}







proc packWaitForVirtualBase {exitBtn skipBtn} {

        global huge_font big_font color3 colorMedium
        
        pack forget .configDisplay
        pack forget .navDisplay
        
        # configure and pack buttons
        if {$skipBtn != "!"} {
          SnazzyButton::setText .fmodal.input.r1.b0 $skipBtn 0.5        
          pack .fmodal.input.r1.b0 -side right -padx 5 -pady 5
        }
        
        # pack the exit button
        SnazzyButton::setText .fmodal.input.exit $exitBtn 0.2        
        pack .fmodal.input.exit -side left -padx 5 -pady 5 -anchor sw

        pack .fmodal.input.r1 -side bottom -anchor se
    }
    
    
    proc actDisplayWaitForStepOneVirtualBase {titleLbl configUserPortsBtn} {
        
        # configure and pack title
        .fmodal.display.l0 configure -text $titleLbl
        pack .fmodal.display.l0 -side top -pady 10
        
        # configure and pack Configure User Ports button
        SnazzyButton::setText .fmodal.input.r1.b1 $configUserPortsBtn 0.5        
        pack .fmodal.input.r1.b1 -side right -padx 5 -pady 5

    }
    
    
    proc actDisplayWaitForWaasEgnosVirtualBase {titleLbl configWaasEgnosBtn} {
        
        # configure and pack title
        .fmodal.display.l0 configure -text $titleLbl
        pack .fmodal.display.l0 -side top -pady 10
        
        # configure and pack Configure WAAS / EGNOS button
        SnazzyButton::setText .fmodal.input.r1.b1 $configWaasEgnosBtn 0.5        
        pack .fmodal.input.r1.b1 -side right -padx 5 -pady 5

    }
