##############################################################################
#
# sync/src/tcl/selectbase.tcl
#
# Screen to display selectbase selections
#
# RA - created
#
# Copyright (c) 2005 Novariant Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    # image create photo ExclamationPoint -format gif -file ExclamationPoint.gif

    # screen3 manual menu ........................................................
    frame .ftop -width 600 -height 455

    label .ftop.title -font $huge_font -width 250 \
	-text "Synchronize Base Stations" -pady 10
    place .ftop.title -relx .5 -y 0 -anchor n

    image create photo btnBlueQuestionU -format gif -file \
	${tclPath}gif/btnBlueQuestionU.gif
    image create photo btnBlueQuestionD -format gif -file \
	${tclPath}gif/btnBlueQuestionD.gif

    SnazzyButton::create .ftop.help btnBlueQuestionU btnBlueQuestionD 0.5 \
                         "beepOnce; post $DISP_BTN0_SIG 0" ""

    place .ftop.help -relx 0.97 -y 5 -width 46 -height 46 -anchor ne

    frame .ftop.conflict -width 600 -height 400

    label .ftop.conflict.attention -font $big_font \
	-text "Touch the name of the next base station you would\nlike to synchronize:"
    place .ftop.conflict.attention -relx .5 -y 10 -anchor n 

    label .ftop.conflict.title -font $medium_font -width 300
    place .ftop.conflict.title -relx .5 -y 55 -anchor n

    label .ftop.conflict.allsynced -font $huge_font -width 300

    label .ftop.conflict.remoteLbl -text "On Your Sync Disk:" -font $medium_font 
    place .ftop.conflict.remoteLbl -relx 0.20 -y 90 -anchor n

    scrollbar .ftop.conflict.sbar1 -orient vertical \
	-command [list .ftop.conflict.remoteTxt yview] \
	-width 38 

    scrollbar .ftop.conflict.sbar2 -orient vertical \
	-command [list .ftop.conflict.localTxt yview] \
	-width 38

    listbox .ftop.conflict.remoteTxt -width 28 -height 16 -font $small_font \
	-exportselection 0 \
	-yscrollcommand [list .ftop.conflict.sbar1 set] \
	-background white -selectbackground gray

    place .ftop.conflict.sbar1 -relx 0.0 -y 110 -height 274   
    place .ftop.conflict.remoteTxt -relx 0.245 -y 110 -anchor n

    bind .ftop.conflict.remoteTxt <ButtonRelease-1> \
	{post $DISP_CANVAS1_SIG 1}

    label .ftop.conflict.localLbl -text "On Your GPS System:" -font $medium_font
    place .ftop.conflict.localLbl -relx 0.80 -y 90 -anchor n

    listbox .ftop.conflict.localTxt -width 28 -height 16 -font $small_font \
	-exportselection 0 \
	-yscrollcommand [list .ftop.conflict.sbar2 set] \
	-background white -selectbackground gray

    place .ftop.conflict.sbar2 -relx .925 -y 110 -height 274                             
    place .ftop.conflict.localTxt -relx 0.755 -y 110 -anchor n

    bind .ftop.conflict.localTxt <ButtonRelease-1> \
	{post $DISP_CANVAS0_SIG 0}

    SnazzyButton::create .ftop.conflict.toLocal btnBlueM2U btnBlueM2D \
	0.5 "beepOnce; post $DISP_BTN1_SIG 1" "Copy >>"

    SnazzyButton::create .ftop.conflict.toRemote btnBlueM2U btnBlueM2D \
	0.5 "beepOnce; post $DISP_BTN2_SIG 2" "<< Copy"

    SnazzyButton::create .ftop.conflict.delLocal btnBlueM2U btnBlueM2D \
	0.5 "beepOnce; post $DISP_BTN3_SIG 3" "Delete ->"

    SnazzyButton::create .ftop.conflict.delRemote btnBlueM2U btnBlueM2D \
	0.5 "beepOnce; post $DISP_BTN4_SIG 4" "<- Delete"

    SnazzyButton::create .ftop.conflict.viewLocal btnBlueM2U btnBlueM2D \
	0.5 "beepOnce; post $DISP_BTN5_SIG 5" "View ->"

    SnazzyButton::create .ftop.conflict.viewRemote btnBlueM2U btnBlueM2D \
	0.5 "beepOnce; post $DISP_BTN5_SIG 5" "<- View"

    SnazzyButton::create .ftop.conflict.viewData btnBlueM2U btnBlueM2D \
	0.5 "beepOnce; post $DISP_BTN6_SIG 6" "View\nData"

    SnazzyButton::create .ftop.conflict.viewFields btnBlueM2U btnBlueM2D \
	0.5 "beepOnce; post $DISP_BTN7_SIG 7" "View\nFields"

    SnazzyButton::create .ftop.conflict.finished btnBlueM2U btnBlueM2D \
	0.5 "beepOnce; post $DISP_BTN8_SIG 8" "Finished"
    place .ftop.conflict.finished -relx 0.501 -y 320 -anchor n

    SnazzyButton::create .ftop.conflict.return btnBlueM2U btnBlueM2D \
	0.5 "beepOnce; post $DISP_BTN9_SIG 9" "Return"

    SnazzyButton::create .ftop.conflict.skip btnBlueM2U btnBlueM2D \
	0.5 "beepOnce; post $DISP_BTN9_SIG 10" "Skip"

    SnazzyButton::create .ftop.conflict.ok btnAcceptU btnAcceptD 0.3 \
	"beepOnce; post $DISP_BTN8_SIG 8" "Ok"

    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry { t att rlbl llbl cplocal cpremote dlocal dremote vlocal vremote \
		    fini return skip accept } {
	global huge_font color3

	.ftop.title configure -text $t
	.ftop.conflict.attention configure -text $att
	.ftop.conflict.remoteLbl configure -text $rlbl
	.ftop.conflict.localLbl configure -text $llbl
	SnazzyButton::setText .ftop.conflict.toLocal $cplocal 0.5
	SnazzyButton::setText .ftop.conflict.toRemote   $cpremote 0.5
	SnazzyButton::setText .ftop.conflict.delLocal  $dlocal 0.5
	SnazzyButton::setText .ftop.conflict.delRemote  $dremote 0.5
	SnazzyButton::setText .ftop.conflict.viewLocal  $vlocal 0.5
	SnazzyButton::setText .ftop.conflict.viewRemote  $vremote 0.5
	SnazzyButton::setText .ftop.conflict.finished  $fini 0.5
	SnazzyButton::setText .ftop.conflict.return  $return 0.5
	SnazzyButton::setText .ftop.conflict.skip  $skip 0.5
	SnazzyButton::setText .ftop.conflict.ok  $accept 0.5
	place .ftop.conflict -relx 0.04 -y 50
        pack .ftop -fill both -expand yes
    }


    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
        pack .ftop -fill both -expand yes
    }

    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------

    proc actListboxInsert { where item } {
	#puts "selectBase -- insert $item"
	$where insert end $item
    }

    proc actListboxGetCurselection {where} {
	if { [$where index end] != 0} {
	    set index [$where curselection]
	    return [$where get $index]
	} else {
	    return "!"             ;# ! tells the C side the listbox was empty
	}
    }

    proc actListboxSetCurselection {where item} {
	$where selection clear 0 end
	$where selection set $item $item
    }

    proc actListboxClearCurselection {where} {
	$where selection clear 0 end
    }

    proc actForgetButtons { } {
	place forget .ftop.conflict.toLocal
	place forget .ftop.conflict.toRemote
	place forget .ftop.conflict.delLocal
	place forget .ftop.conflict.delRemote
	place forget .ftop.conflict.viewLocal
	place forget .ftop.conflict.viewRemote
	place forget .ftop.conflict.viewData
	place forget .ftop.conflict.viewFields
	place forget .ftop.conflict.return
    }

    proc actButtonsLocal { prompt entry } {
	actForgetButtons
	.ftop.conflict.attention configure -text " "
	.ftop.conflict.title configure -text \
	    "$entry $prompt"
	place .ftop.conflict.toRemote -relx 0.501 -y 95 -anchor n
	place .ftop.conflict.delLocal -relx 0.501 -y 170 -anchor n
	place .ftop.conflict.viewLocal -relx 0.501 -y 245 -anchor n
	place .ftop.conflict.finished -relx 0.501 -y 320 -anchor n
    }

    proc actButtonsRemote { prompt entry } {
	actForgetButtons
	.ftop.conflict.attention configure -text " "
	.ftop.conflict.title configure -text \
	    "$entry $prompt"
	place .ftop.conflict.toLocal -relx 0.501 -y 95 -anchor n
	place .ftop.conflict.delRemote -relx 0.501 -y 170 -anchor n
	place .ftop.conflict.viewRemote -relx 0.501 -y 245 -anchor n
	place .ftop.conflict.finished -relx 0.501 -y 320 -anchor n
    }

    proc actButtonsInternalConflict { prompt entry view} {
	actForgetButtons
	.ftop.conflict.attention configure -text " "
	.ftop.conflict.title configure -text "$prompt $entry"
	place .ftop.conflict.toLocal -relx 0.501 -y 95 -anchor n
	place .ftop.conflict.toRemote -relx 0.501 -y 170 -anchor n
	if {$view != "!"} {
	    .ftop.conflict.viewData configure -text $view
	    place .ftop.conflict.viewData -relx 0.501 -y 245 -anchor n
	}
	place .ftop.conflict.finished -relx 0.501 -y 320 -anchor n
    }

    proc actButtonsDependentConflict { prompt entry view} {
	actForgetButtons
	.ftop.conflict.attention configure -text " "
	.ftop.conflict.title configure -text  "$prompt $entry"
	if {$view != "!"} {
	    .ftop.conflict.viewFields configure -text $view
	    place .ftop.conflict.viewFields -relx 0.501 -y 245 -anchor n
	}
	place .ftop.conflict.finished -relx 0.501 -y 320 -anchor n
    }

    proc actButtonsLocalView { prompt entry } {
	actForgetButtons
	.ftop.conflict.attention configure -text " "
	.ftop.conflict.title configure -text  "$entry $prompt"
	place .ftop.conflict.return -relx 0.501 -y 320 -anchor n
    }

    proc actButtonsRemoteView { prompt entry } {
	actForgetButtons
	.ftop.conflict.attention configure -text " "
	.ftop.conflict.title configure -text "$entry $prompt"
	place .ftop.conflict.return -relx 0.501 -y 320 -anchor n
    }

    proc actButtonsConflictView { prompt entry returnbtn } {
	actForgetButtons
	.ftop.conflict.attention configure -text " "
	.ftop.conflict.title configure -text "$prompt $entry"
	.ftop.conflict.return configure -text $returnbtn
	place .ftop.conflict.toLocal -relx 0.501 -y 95 -anchor n
	place .ftop.conflict.toRemote -relx 0.501 -y 170 -anchor n
	place .ftop.conflict.return -relx 0.501 -y 320 -anchor n
    }

    proc actButtonsInternalConflictView { entry } {
	actForgetButtons
	.ftop.conflict.attention configure -text " "
	.ftop.conflict.title configure -text $entry
	place .ftop.conflict.toLocal -relx 0.501 -y 95 -anchor n
	place .ftop.conflict.toRemote -relx 0.501 -y 170 -anchor n
	place .ftop.conflict.return -relx 0.501 -y 320 -anchor n
    }

    proc actButtonsInternalConflictSkipView { entry } {
	actForgetButtons
	.ftop.conflict.attention configure -text " "
	.ftop.conflict.title configure -text $entry
	place .ftop.conflict.toLocal -relx 0.501 -y 95 -anchor n
	place .ftop.conflict.toRemote -relx 0.501 -y 170 -anchor n
	place .ftop.conflict.skip -relx 0.501 -y 320 -anchor n
    }

    proc actButtonsDependentConflictView { entry } {
	actForgetButtons
	.ftop.conflict.attention configure -text " "
	.ftop.conflict.title configure -text $entry
	place .ftop.conflict.return -relx 0.501 -y 320 -anchor n
    }

    proc actButtonsFinished { msg } {
	actForgetButtons
	.ftop.conflict.attention configure -text $msg
	.ftop.conflict.title configure -text  " "
	place .ftop.conflict.finished -relx 0.501 -y 320 -anchor n
     }

    proc actClearListBoxes {} {
	.ftop.conflict.localTxt delete 0 end
	.ftop.conflict.remoteTxt delete 0 end
    }

    proc actAllSynced { msg } {
	actForgetButtons
	global huge_font
	.ftop.conflict.allsynced configure -font $huge_font -text $msg
	place .ftop.conflict.allsynced -relx .5 -y 90 -anchor n
	.ftop.conflict.attention configure -text  " "
	.ftop.conflict.title configure -text  " "
	place forget .ftop.conflict.remoteTxt
	place forget .ftop.conflict.sbar1
	place forget .ftop.conflict.localTxt
	place forget .ftop.conflict.sbar2
	place forget .ftop.conflict.remoteLbl
	place forget .ftop.conflict.localLbl
	place forget .ftop.title
	place forget .ftop.help
	#place .ftop.conflict.ok -relx 1.0 -y 400 -anchor se
    }

    proc actCopySuccess {typename copiedto entryname} {
	global medium_font
	.ftop.conflict.title configure -font $medium_font -text \
	    "$entryname successfully copied to $typename."
    }

}
