##############################################################################
#
# vc/src/tcl/configuser.tcl
#
# Screen to display details about the User port configuration.
#
# 20030620 M_S - created
#
# Copyright (c) 2002-2003 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it on exit
    frame .ftop

    # title and error indicator
    label .ftop.title -font $huge_font
    place .ftop.title -relx 0.5 -y 15 -anchor n
    
    # port 1
    frame .ftop.port1Comment -width 240 -height 380 \
        -borderwidth 2 -relief sunken

    label .ftop.port1Comment.msg  -font $big_font
    place .ftop.port1Comment.msg -relx 0.5 -y 20 -anchor n

    frame .ftop.port1  -width 240 -height 380 -borderwidth 2 -relief sunken
    label .ftop.port1.portLbl -font $big_font
    place .ftop.port1.portLbl -x 120 -y 10 -anchor n  


    button .ftop.port1.baudUp -width 15 -height 2 \
            -command {beepOnce; post $DISP_BTN2_SIG 1 } \
            -background $color3 -activebackground $color3
    place .ftop.port1.baudUp -relx 1.0 -x -20 -y 30 -anchor ne  
    
    label .ftop.port1.baudLbl -font $big_font -text "baud:"
    place .ftop.port1.baudLbl -x 60  -y 60 -anchor ne  
    label .ftop.port1.baud -width 15 -font $big_font \
          -borderwidth 2 -relief sunken
    place .ftop.port1.baud  -relx 1.0 -x -22 -y 70 -anchor ne  
    button .ftop.port1.baudDown -width 15 -height 2 \
          -command {beepOnce; post $DISP_BTN2_SIG -1 } \
          -background $color3 -activebackground $color3
    place .ftop.port1.baudDown -relx 1.0 -x -20 -y 90 -anchor ne  

    button .ftop.port1.test -width 15 -height 2 \
            -command {beepOnce; post $DISP_BTN3_SIG 3 } \
            -background $color3 -activebackground $color2       
    
    place .ftop.port1.test -relx 1.0 -x -25 -y 150 -anchor ne

    label .ftop.port1.send -width 15 -font $big_font 

    place .ftop.port1.send -relx 1.0 -x -20 -y 220 -anchor ne

 
   label .ftop.port1.receive -width 15 -font $big_font 

    place .ftop.port1.receive -relx 1.0 -x -20 -y 280 -anchor ne
   
    # port 2
    frame .ftop.port2Comment -width 240 -height 380 \
          -borderwidth 2 -relief sunken
    label .ftop.port2Comment.msg  -font $big_font
    place .ftop.port2Comment.msg -relx 0.5 -y 20 -anchor n


    frame .ftop.port2  -width 240 -height 380 -borderwidth 2 -relief sunken
    label .ftop.port2.portLbl -font $big_font
    place .ftop.port2.portLbl -x 120 -y 10 -anchor n  


    button .ftop.port2.baudUp -width 15 -height 2 \
          -command {beepOnce; post $DISP_BTN4_SIG 1 } \
          -background $color3 -activebackground $color3
    place .ftop.port2.baudUp -relx 1.0 -x -20  -y 30 -anchor ne  
    label .ftop.port2.baudLbl -font $big_font -text "baud:"
    place .ftop.port2.baudLbl -x 60  -y 60 -anchor ne  
    label .ftop.port2.baud -width 15 -font $big_font \
          -borderwidth 2 -relief sunken
    place .ftop.port2.baud  -relx 1.0 -x -22 -y 70 -anchor ne  
    button .ftop.port2.baudDown -width 15 -height 2 \
          -command {beepOnce; post $DISP_BTN4_SIG -1 } \
          -background $color3 -activebackground $color3
    place .ftop.port2.baudDown -relx 1.0 -x -20 -y 90 -anchor ne  


    button .ftop.port2.test -width 15 -height 2 \
            -command {beepOnce; post $DISP_BTN5_SIG 5 } \
            -background $color3 -activebackground $color2       
    place .ftop.port2.test -relx 1.0 -x -25 -y 150 -anchor ne


    label .ftop.port2.send -width 15 -font $big_font 

    place .ftop.port2.send -relx 1.0 -x -20 -y 220 -anchor ne


   label .ftop.port2.receive -width 15 -font $big_font 

    place .ftop.port2.receive -relx 1.0 -x -20 -y 280 -anchor ne

    # set portSel 1    

    # buttons
    SnazzyButton::create .ftop.return btnKhakiU btnKhakiD 0.5 \
                 "beepOnce; post $DISP_BTN9_SIG 9;" "Return To Previous Menu"
    place .ftop.return -x 10 -rely 1.0 -y -10 -anchor sw            

    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    
    proc actEntry { titleLbl returnBtn portLbl baudLbl 
                    port1Comment port2Comment 
                    upLbl downLbl looptest} {

        .ftop.title configure -text $titleLbl
        .ftop.return configure -text $returnBtn

        if {$port1Comment == "!"} {
           .ftop.port1.portLbl configure -text ${portLbl}1
           .ftop.port1.baudLbl configure -text $baudLbl
           .ftop.port1.baudUp configure -text $upLbl
           .ftop.port1.baudDown configure -text $downLbl
           .ftop.port1.test configure -text $looptest  
           #pack .ftop -fill both -expand yes
            place .ftop.port1 -x 130 -rely 1.0 -y -10 -anchor sw
        } else {
           .ftop.port1Comment.msg configure \
               -text "${portLbl}1\n \n$port1Comment"
            place .ftop.port1Comment -x 130 -rely 1.0 -y -10 -anchor sw
        }
        if {$port2Comment == "!"} {
           .ftop.port2.portLbl configure -text ${portLbl}2
           .ftop.port2.baudLbl configure -text $baudLbl
           .ftop.port2.baudUp configure -text $upLbl
           .ftop.port2.baudDown configure -text $downLbl
           .ftop.port2.test configure -text $looptest  
           place .ftop.port2 -x 390 -rely 1.0 -y -10 -anchor sw
        } else {
            .ftop.port2Comment.msg configure \
                -text "${portLbl}2\n \n$port2Comment"
            #.ftop.port2Comment.enable configure -text
           place .ftop.port2Comment -x 390 -rely 1.0 -y -10 -anchor sw
        }
        pack .ftop -fill both -expand yes
    }

    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }

    #-------------------------------------------------------------------------
    # other action procedures (called by GuiMgr)
    #-------------------------------------------------------------------------

    proc actSetBaud1 { baud1 } {
        .ftop.port1.baud configure -text $baud1
         #pack .ftop.port1.baud
    }
    
    proc actSetBaud2 { baud2 } {
        .ftop.port2.baud configure -text $baud2
     #   .ftop.port1.test configure -text $baud2
    }

  #  proc actSetPorts { config1 config2 } {
   #     global port1sel port2sel
    #    set port1sel $config1    
     #   set port2sel $config2    
    #}

    proc actSendLoopPort1 { status } {
      .ftop.port1.send configure -text $status     
    }

    proc actSendLoopPort2 { status } {
      .ftop.port2.send configure -text $status     
    }

    proc actRcvLoopPort1 { status } {
      .ftop.port1.receive configure -text $status     
    }

    proc actRcvLoopPort2 { status } {
      .ftop.port2.receive configure -text $status     
    }



}
