##############################################################################
#
# vc/src/tcl/setimezone.tcl
#
# Screen to set time zone.
#
# 20040129 QC - created
#
# Copyright (c) 2002 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it on exit
    frame .ftop

    # Define and pack the screen layout

    # Title
    label .ftop.title -text "Storm Mode and Partial Fix"
    # Set Help Button ->button1
    SnazzyButton::create .ftop.title.1 btnBlueQuestionU \
      btnBlueQuestionD 0.5 "beepOnce; post $DISP_BTN1_SIG 1;"


    # Input frame
    frame .ftop.partial
    
    #Set PartialFix Button -->button2
    SnazzyButton::create .ftop.partial.1 btnGreenSliderDChecked \
      btnGreenSliderUChecked 0.5 "beepOnce; post $DISP_BTN2_SIG 2;"

    label .ftop.partial.txt -text "Use Partial Fix" -font $medium_font
  
     #   -height 2 -width 60 -variable stormmode \
      #  -command {beepOnce; post $DISP_BTN1_SIG 1} -activebackground $color6 \
      #  -text "Partial Fix" -font $big_font -value 0 -anchor sw
    
    pack .ftop.partial.1  -side left -padx 10 -pady 10
    pack .ftop.partial.txt -side left -padx 12

    
   

    #set weatherCondition  Button button3 and button4
    frame .ftop.choice -bd 1 -relief solid
   
    frame .ftop.choice.title -bd 1 -relief solid -bg lightgray
    label .ftop.choice.title.txt -text "Set Weather Conditions" -font $medium_font \
      -bd 1 -bg lightgray
    
    frame .ftop.choice.content
   

    SnazzyButton::create .ftop.choice.content.1 btnBlueU \
      btnBlueUChecked 0.5 "beepOnce; post $DISP_BTN3_SIG 3;"


    SnazzyButton::create .ftop.choice.content.2 btnBlueU \
      btnBlueUChecked 0.5 "beepOnce; post $DISP_BTN4_SIG 4;"

    pack .ftop.choice.title.txt -side left -fill both -expand yes    
    pack .ftop.choice.content.1 -side left -padx 10  -pady 10 -anchor sw
    pack .ftop.choice.content.2 -side right -padx 10 -pady 10 -anchor sw
   # pack .ftop.input.choice -side top -padx 20 -anchor sw
#    pack .ftop.input.choice4 -side top -padx 20 -anchor sw

    # Cancel/Accept frame
    frame .ftop.input2
    SnazzyButton::create .ftop.input2.cancel btnKhakiU btnKhakiD 0.5 \
                 "beepOnce; post $DISP_BTN9_SIG 9;" "Return To Previous Menu"
        
    pack .ftop.input2.cancel -side left  -padx 10 -pady 10 -anchor sw
    #pack .ftop.input2.accept -side right -padx 10 -pady 10 -anchor sw

    # Pack .ftop
    pack .ftop.title -side top -pady 3 -fill both -expand yes
    pack .ftop.title.1  -side right -padx 20
    pack .ftop.partial -side top -padx 50
    #pack .ftop.partial.0 -side top
    pack .ftop.choice -side top -padx 100
    pack .ftop.choice.title -side top -fill both -expand yes

    pack .ftop.choice.content -side top -padx 2
    pack .ftop.input2 -side bottom -anchor se -fill both -expand yes
                
    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry {titleLbl partialfixLbl sunnyLbl stormLbl returnBtn \
                   acceptBtn stormmod weatherstatus} {
       # diagnostics("stormMode actEntry");
        set stormmode $stormmod
        puts stdout "stormmode: $stormmode"
        set btnid [expr $stormmode + 7]
        puts stdout "btnid: $btnid"

         
        .ftop.title configure -text \
                               "$titleLbl\n"
        SnazzyButton::setText .ftop.input2.cancel $returnBtn 0.5
        #SnazzyButton::setText .ftop.input2.accept $acceptBtn 0.5
        
        .ftop.choice.content.1 configure -text $sunnyLbl
        .ftop.choice.content.2 configure -text $stormLbl
        
        pack .ftop -fill both -expand yes
    }

    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }

    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------

   #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------

    proc actPushbutton {buttonName img} {
	SnazzyButton::setImage $buttonName $img checkboxD1 0.5
    }

#    if (doBases) {
#      TkDisplay::action("actPushbutton",
#			".ftop.display.left.base.btn checkboxD1");
#    }

    #-------------------------------------------------------------------------
    # Delegated procedures
    #-------------------------------------------------------------------------

    #-------------------------------------------------------------------------
    # Local procedures
    # {MLE-020418: Tcl/Tk goal should be to get rid of all local procedures, 
    # because they represent intelligence, which the display should not have.}
    #-------------------------------------------------------------------------
    # Local procedures
}
