proc slider { me numSteps sig } {
    global medium_font big_font color3
    
    set readoutWidth  160
    set readoutHeight  45
    set btnWidth       60
    set titleHeight    12

    canvas $me -width [expr $readoutWidth + 2*$btnWidth + 4] \
        -height [expr $readoutHeight + $titleHeight + 4] \
        -relief raised -borderwidth 0
    button $me.neg -text "-" -font $big_font -width 3 -height 2 \
           -background $color3 -activebackground $color3 \
              -command "beepOnce; post $sig -1"  
    button $me.pos -text "+" -font $big_font -width 3 -height 2 \
           -background $color3 -activebackground $color3 \
           -command "beepOnce; post $sig 1"
    $me create window [expr 2 + $btnWidth] $titleHeight \
             -anchor ne -window $me.neg
    $me create window [expr 6 + $btnWidth + $readoutWidth] $titleHeight \
             -anchor nw -window $me.pos
    $me create text [expr 2 + $btnWidth + 2 + $readoutWidth/2] 2 \
           -anchor n -font $medium_font -tags title    
    $me create text [expr 2 + $btnWidth + 8] [expr $titleHeight + 8] \
            -anchor nw -font $medium_font -text 10 -tags value
    
    # create an off-screen text to store number of steps        
    $me create text -20 0 -text $numSteps -tags numSteps
            

    set x0 [expr 2 + $btnWidth + 2]

    set notchWidth  [expr 0.6*$readoutWidth/$numSteps]
    for {set i 0} {$i < $numSteps} {incr i} {
        set x  [expr $x0 + $readoutWidth*($i + 0.5)/$numSteps]
        set y1 [expr $titleHeight + \
                $readoutHeight*(0.9 - 0.8*($i+0.5)/$numSteps)]
        set y2 [expr $titleHeight + $readoutHeight]
        $me create line $x $y1 $x $y2 -width $notchWidth \
            -fill grey -tags notch$i
    }

    set x1 [expr $x0 + $readoutWidth/2 - 1]
    set x2 [expr $x0 + $readoutWidth]
    set y1 [expr $titleHeight + $readoutHeight - 3]
    set y2 [expr $titleHeight + $readoutHeight]
    $me create line $x0 $y2 $x2 $y2 
    $me create line $x0 $y1 $x0 $y2 
    $me create line $x1 $y1 $x1 $y2 
    $me create line $x2 $y1 $x2 $y2
    
    return $me 
}

proc sliderConfigureTitle { me title } {
   $me itemconfigure title -text $title
}

proc sliderConfigureButtons { me negBtn posBtn } {
   $me.neg configure -text $negBtn
   $me.pos configure -text $posBtn
}

proc sliderSetValue { me val notch } {
    $me itemconfigure value -text $val
    set numSteps [$me itemcget numSteps -text]
    for {set i 0} {$i < $notch} {incr i} {
        $me itemconfigure notch$i -fill "green"
    }
    for {set i $notch} {$i < $numSteps} {incr i} {
        $me itemconfigure notch$i -fill "grey"
    }
}
