#!/bin/sh

# make sure local devices are writable
mount none / -o remount
mount none /mnt/sandisk -o remount

# clear flags for Complete and Failed
rm /mnt/sandisk/upgrade/apps/softwareupgrade/backupComplete
rm /mnt/sandisk/upgrade/apps/softwareupgrade/backupFailed
rm /mnt/sandisk/upgrade/apps/softwareupgrade/RevB_OS;

# Get version of OS (Rev B or Rev C)
cd /mnt/sandisk/upgrade/apps/softwareupgrade
. ./utOSver.sh

# Make sure User Terminal can be detected
if [ $OS_VER = UNKNOWN ]; then
   echo "Unknown OS" > /mnt/sandisk/upgrade/apps/softwareupgrade/backupFailed
   mount none / -ro remount
   mount none /mnt/sandisk -ro remount
   exit;
fi

# jobComplete is a file that acts as a flag
# it is read by the user program
rm /mnt/sandisk/upgrade/apps/softwareupgrade/backupComplete

mkdir -p /configuration/currdir0
mount -t jffs2 /dev/mtdblock4 /configuration/currdir0
mkdir  /ut
mount -t jffs2 /dev/mtdblock3 /ut
cd /mnt/sandisk/upgrade/backup

#if Rev C OS type
rm /tmp/tarout
if [ $OS_VER = REV_C ]; then
   # Remove existing backup files
   echo "Removing old backup file";
   rm /mnt/sandisk/upgrade/backup/backup_RevC.tar
   echo "Tarring RevC right now";
   tar -cf backup_RevC.tar /configuration/currdir0 /ut/mnt/apps /ut/lib  \
         /ut/etc/init.d/rcS \
         /ut/about.txt \
         /ut/A5SupportVersion.sh 2> /tmp/tarout;
# else if Rev B OS type
else 
   echo "Cannot Backup Rev B;" > backupFailed
   touch /mnt/sandisk/upgrade/apps/softwareupgrade/RevB_OS;
#   touch /mnt/sandisk/upgrade/apps/softwareupgrade/backupFailed;
   exit;
fi 

# Save tar test results.  Do it now before any more system calls.
# Sadly, this does NOT work.  Left here for documentation
# TAR_RESULTS=$?

umount /configuration/currdir0
rm -rf /configuration/currdir0
umount /ut
rm -rf /ut

# test for tar results.  
ERROR=$(grep "Error exit" /tmp/tarout | cut -d " " -f 2)

if [ $ERROR = Error ]; then
   # remove backup files since tar failed.  Don't want user to 
   # reboot and attempt to restore from corrupted files
   rm /mnt/sandisk/upgrade/backup/backup_RevC.tar
#   touch /mnt/sandisk/upgrade/apps/softwareupgrade/backupFailed;
   echo "tar error" > /mnt/sandisk/upgrade/apps/softwareupgrade/backupFailed
else
   touch /mnt/sandisk/upgrade/apps/softwareupgrade/backupComplete;
fi

echo "Backup finished"
