##############################################################################
#
# vc/src/tcl/embeddedgif.tcl
#
# Tcl screens with embedded gif images.
#
# 20031212 MLE, QCHANG, RCM - created
#
# Copyright (c) 2002, 2003 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # Top level frame
    frame .ftop

    # Define and pack the screen layout
    frame .ftop.display         ;# Display Frame

    label .ftop.display.title -text "Space for title"
    label .ftop.display.subtitle -text "Space for subtitle" -justify left \
                                 -font $big_font

    frame .ftop.input           ;# Input Frame
    frame .ftop.input.r1
    SnazzyButton::create .ftop.input.r1.cancel btnKhakiU btnKhakiD 0.5 \
                         "beepOnce; post $DISP_BTN9_SIG 9;" "Cancel"
    SnazzyButton::create .ftop.input.r1.back btnKhakiU btnKhakiD 0.5 \
                         "beepOnce; post $DISP_BTN3_SIG 3;" "Back"
    SnazzyButton::create .ftop.input.r1.accept btnBlueU btnBlueD 0.5 \
                   "beepOnce; post $DISP_BTN1_SIG 1;" "Continue"
    SnazzyButton::create .ftop.input.r1.skip btnBlueU btnBlueD 0.5 \
                   "beepOnce; post $DISP_BTN2_SIG 2;" "Skip"

    SnazzyButton::create .ftop.input.r1.pass btnBlueU btnBlueD 0.5 \
                   "beepOnce; post $DISP_BTN5_SIG 5;" "Pass"
    SnazzyButton::create .ftop.input.r1.fail btnBlueU btnBlueD 0.5 \
                   "beepOnce; post $DISP_BTN6_SIG 6;" "Fail"
    frame .ftop.input.r1.r1
    label .ftop.input.r1.r1.l -text "Current Value:" -font $big_font \
                        -width 15 -anchor e
    label .ftop.input.r1.r1.e -text "1 meter" -font $big_font \
                        -width 16 -anchor w -relief sunken -borderwidth 2
    SnazzyButton::create .ftop.input.r1.r1.b btnBlueMU btnBlueMD 0.5 \
                        "beepOnce; post $DISP_BTN2_SIG 2;" "Change"
    frame .ftop.input.r1.r2
    label .ftop.input.r1.r2.l -text "Current Value:" -font $big_font \
                        -width 15 -anchor e
    label .ftop.input.r1.r2.e -text "1 meter" -font $big_font \
                        -width 16 -anchor w -relief sunken -borderwidth 2
    SnazzyButton::create .ftop.input.r1.r2.b btnBlueMU btnBlueMD 0.5 \
                        "beepOnce; post $DISP_BTN8_SIG 8;" "Change"

    frame .ftop.input.r2
    SnazzyButton::create .ftop.input.r2.left btnBigLeftNudgeU btnBigLeftNudgeD \
                0.5 "beepOnce; post $DISP_BTN4_SIG 4;" ""
    SnazzyButton::create .ftop.input.r2.right btnBigRightNudgeU \
                btnBigRightNudgeD \
                0.5 "beepOnce; post $DISP_BTN0_SIG 0;" ""
    SnazzyButton::create .ftop.input.r2.stop btnBigStopU btnBigStopD \
                0.5 "beepOnce; post $DISP_BTN7_SIG 7;" ""

    pack .ftop.input.r1 -side bottom -padx 5 -fill both -expand yes
    pack .ftop.input -side bottom -padx 5 -pady 5 -fill both -expand yes \
                                                             -anchor s
    #-------------------------------------------------------------------------
    # Entry and exit procedures
    #-------------------------------------------------------------------------
    proc actEntry { packProc__ } {
        
        eval $packProc__
        pack .ftop -fill both -expand yes

    }

    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }

    #-------------------------------------------------------------------------
    # Local procedures
    # {MLE-020418: Tcl/Tk goal should be to get rid of all local procedures, 
    # because they represent intelligence, which the display should not have.}
    #-------------------------------------------------------------------------
    # Local procedures
    proc packWheelbaseMeasurement {title \
                 currentvalueLbl changeBtn cancelBtn acceptBtn gifFilename} {

        .ftop.display.title configure -text $title
        pack .ftop.display.title -side top -padx 15 -pady 15    
        global tclPath
        image create photo embdImage \
            -file ${tclPath}embeddedgif/$gifFilename
        label .ftop.display.image1 -image embdImage
        pack .ftop.display.image1 -side bottom -padx 8 -pady 8 \
                                  -fill both -expand yes
        pack .ftop.display -side top -fill both -expand yes

        .ftop.input.r1.r1.l configure -text $currentvalueLbl
        SnazzyButton::setText .ftop.input.r1.r1.b $changeBtn 0.5
        SnazzyButton::setText .ftop.input.r1.cancel $cancelBtn 0.5
        SnazzyButton::setText .ftop.input.r1.accept $acceptBtn 0.5
        pack .ftop.input.r1.cancel -side left -anchor sw
        pack .ftop.input.r1.r1.l -side left
        pack .ftop.input.r1.r1.e -side left
        pack .ftop.input.r1.r1.b -side left -padx 5
        pack .ftop.input.r1.r1 -side left
        pack .ftop.input.r1.accept -side right -anchor se

    }

    proc packEnterLeverArmMeasurements {title cancelBtn acceptBtn \
                                        gifFilename} {

        .ftop.display.title configure -text $title
        pack .ftop.display.title -side top -padx 5 -pady 5
        global tclPath
        image create photo embdImage \
            -file ${tclPath}embeddedgif/$gifFilename
        label .ftop.display.image1 -image embdImage
        pack .ftop.display.image1 -side bottom -anchor s \
                                               -fill both -expand yes
        pack .ftop.display -side top -padx 5 -fill both -expand yes

        SnazzyButton::setText .ftop.input.r1.cancel $cancelBtn 0.5
        SnazzyButton::setText .ftop.input.r1.accept $acceptBtn 0.5
        pack .ftop.input.r1.cancel -side left -anchor sw
        pack .ftop.input.r1.accept -side right -anchor se

    }
    
    proc packEnterLeverArm {title currentvalueLbl changeBtn \
                    cancelBtn backBtn acceptBtn gifFilename} {

        .ftop.display.title configure -text $title
        pack .ftop.display.title -side top -padx 20 -pady 10
        global tclPath
        image create photo embdImage \
            -file ${tclPath}embeddedgif/$gifFilename
        label .ftop.display.image1 -image embdImage
        pack .ftop.display.image1 -side bottom -padx 8 \
                                  -fill both -expand yes
        pack .ftop.display -side top -fill both -expand yes
        
        SnazzyButton::setText .ftop.input.r1.cancel $cancelBtn 0.5
        pack .ftop.input.r1.cancel -side left -anchor sw

        if {$backBtn != "!"} {
          SnazzyButton::setText .ftop.input.r1.back $backBtn 0.5
          pack .ftop.input.r1.back -side left -anchor sw -padx 5
          .ftop.input.r1.r1.l configure -width 2
        }
        
        if {$backBtn == "!"} {
          .ftop.input.r1.r1.l configure -width 8
        }
        
        .ftop.input.r1.r1.l configure -text $currentvalueLbl
        pack .ftop.input.r1.r1.l -side left
        pack .ftop.input.r1.r1.e -side left
        SnazzyButton::setText .ftop.input.r1.r1.b $changeBtn 0.5
        pack .ftop.input.r1.r1.b -side left -padx 5
        pack .ftop.input.r1.r1 -side left
        SnazzyButton::setText .ftop.input.r1.accept $acceptBtn 0.5
        pack .ftop.input.r1.accept -side right -anchor se

    }


    proc packAttitudeSurvey {title cancelBtn continueBtn gifFilename} {

        .ftop.display.title configure -text $title
        pack .ftop.display.title -side top -padx 5 -pady 5
        global tclPath
        image create photo embdImage \
            -file ${tclPath}embeddedgif/$gifFilename
        label .ftop.display.image1 -image embdImage
        pack .ftop.display.image1 -side bottom -anchor s \
                                               -fill both -expand yes
        pack .ftop.display -side top -padx 5 -fill both -expand yes

        SnazzyButton::setText .ftop.input.r1.cancel $cancelBtn 0.5
        SnazzyButton::setText .ftop.input.r1.accept $continueBtn 0.5
        pack .ftop.input.r1.cancel -side left -anchor sw
        pack .ftop.input.r1.accept -side right -anchor se

    }

    proc packWheelAngle {cancelBtn skipTutorialBtn continueBtn gifFilename} {

        global tclPath
        image create photo embdImage \
            -file ${tclPath}embeddedgif/$gifFilename
        label .ftop.display.image1 -image embdImage
        pack .ftop.display.image1 -side bottom -anchor s \
                                               -fill both -expand yes
        pack .ftop.display -side top -padx 5 -fill both -expand yes

        SnazzyButton::setText .ftop.input.r1.cancel $cancelBtn 0.5
        SnazzyButton::setText .ftop.input.r1.skip $skipTutorialBtn 0.5
        SnazzyButton::setText .ftop.input.r1.accept $continueBtn 0.5
        pack .ftop.input.r1.cancel -side left -anchor sw
        pack .ftop.input.r1.accept -side right -anchor se
        pack .ftop.input.r1.skip -side right -anchor se

    }

    proc packWheeledCalWithBackBtn {cancelBtn continueBtn backBtn \
                                    gifFilename} {

        global tclPath
        image create photo embdImage \
            -file ${tclPath}embeddedgif/$gifFilename
        label .ftop.display.image1 -image embdImage
        pack .ftop.display.image1 -side bottom -anchor s \
                                               -fill both -expand yes
        pack .ftop.display -side top -padx 5 -fill both -expand yes

        SnazzyButton::setText .ftop.input.r1.cancel $cancelBtn 0.5
        SnazzyButton::setText .ftop.input.r1.back $backBtn 0.5
        SnazzyButton::setText .ftop.input.r1.accept $continueBtn 0.5
        pack .ftop.input.r1.cancel -side left -anchor sw
        pack .ftop.input.r1.back -side left -anchor sw -padx 5
        pack .ftop.input.r1.accept -side right -anchor se

    }

    proc packWheelAngleWith2Gif {cancelBtn continueBtn backBtn \
                                 gifFilename1 gifFilename2} {

        global tclPath
        image create photo embdImage1 \
            -file ${tclPath}embeddedgif/$gifFilename1
        label .ftop.display.image1 -image embdImage1
        pack .ftop.display.image1 -side bottom -anchor s \
                                               -fill both -expand yes
        pack .ftop.display -side top -padx 5 -fill both -expand yes

        SnazzyButton::setText .ftop.input.r1.cancel $cancelBtn 0.5
        SnazzyButton::setText .ftop.input.r1.back $backBtn 0.5
        SnazzyButton::setText .ftop.input.r1.accept $continueBtn 0.5
        image create photo embdImage2 \
            -file ${tclPath}embeddedgif/$gifFilename2
        label .ftop.input.r1.image2 -image embdImage2
        pack .ftop.input.r1.cancel -side left -anchor sw
        pack .ftop.input.r1.back -side left -anchor sw -padx 5
        pack .ftop.input.r1.image2 -side left -anchor sw \
                                               -fill both -expand yes
        pack .ftop.input.r1.accept -side right -anchor se

    }

    proc packBeginAttitudeSurvey {title cancelBtn beginsurveyBtn \
                                  skipsurveyBtn gifFilename} {

        .ftop.display.title configure -text $title
        pack .ftop.display.title -side top -padx 5 -pady 5
        global tclPath
        image create photo embdImage \
            -file ${tclPath}embeddedgif/$gifFilename
        label .ftop.display.image1 -image embdImage
        pack .ftop.display.image1 -side bottom -anchor s \
                                               -fill both -expand yes
        pack .ftop.display -side top -padx 5 -fill both -expand yes

        SnazzyButton::setText .ftop.input.r1.cancel $cancelBtn 0.5
        SnazzyButton::setText .ftop.input.r1.accept $beginsurveyBtn 0.5
        SnazzyButton::setText .ftop.input.r1.back $skipsurveyBtn 0.5
        pack .ftop.input.r1.cancel -side left -anchor sw
        pack .ftop.input.r1.accept -side right -anchor se
        pack .ftop.input.r1.back -side right -anchor se -padx 5

    }

    proc packSystemTest {title cancelBtn continueBtn \
                                  shutdownsystemBtn gifFilename} {

        .ftop.display.title configure -text $title
        pack .ftop.display.title -side top -padx 5 -pady 5
        global tclPath
        image create photo embdImage \
            -file ${tclPath}embeddedgif/$gifFilename
        label .ftop.display.image1 -image embdImage
        pack .ftop.display.image1 -side bottom -anchor s \
                                               -fill both -expand yes
        pack .ftop.display -side top -padx 5 -fill both -expand yes

        SnazzyButton::setText .ftop.input.r1.cancel $cancelBtn 0.5
        SnazzyButton::setText .ftop.input.r1.accept $continueBtn 0.5
        SnazzyButton::setImage .ftop.input.r1.back btnRedU btnRedD 0.5
        SnazzyButton::setText .ftop.input.r1.back $shutdownsystemBtn 0.5
        pack .ftop.input.r1.cancel -side left -anchor sw
        pack .ftop.input.r1.accept -side right -anchor se
        pack .ftop.input.r1.back -side right -anchor se -padx 5

    }

    proc packManualSteeringTest {cancelBtn passBtn \
                                  failBtn gifFilename} {

        global tclPath
        image create photo embdImage \
            -file ${tclPath}embeddedgif/$gifFilename
        label .ftop.display.image1 -image embdImage
        pack .ftop.display.image1 -side bottom -anchor s \
                                               -fill both -expand yes
        pack .ftop.display -side top -padx 5 -fill both -expand yes

        SnazzyButton::setText .ftop.input.r1.cancel $cancelBtn 0.5
        SnazzyButton::setText .ftop.input.r1.pass $passBtn 0.5
        SnazzyButton::setText .ftop.input.r1.fail $failBtn 0.5
        pack .ftop.input.r1.cancel -side left -anchor sw
        pack .ftop.input.r1.pass -side right -anchor se
        pack .ftop.input.r1.fail -side right -anchor se -padx 5

    }
    
    proc packWheelAngleSensorTest {valueLbl cancelBtn passBtn \
                                   failBtn gifFilename} {

        global tclPath
        image create photo embdImage \
            -file ${tclPath}embeddedgif/$gifFilename
        label .ftop.display.image1 -image embdImage
        pack .ftop.display.image1 -side bottom -anchor s \
                                               -fill both -expand yes
        pack .ftop.display -side top -padx 5 -fill both -expand yes

        SnazzyButton::setText .ftop.input.r1.cancel $cancelBtn 0.5
        SnazzyButton::setText .ftop.input.r1.pass $passBtn 0.5
        SnazzyButton::setText .ftop.input.r1.fail $failBtn 0.5
        pack .ftop.input.r1.cancel -side left -anchor sw
        pack .ftop.input.r1.pass -side right -anchor se
        pack .ftop.input.r1.fail -side right -anchor se -padx 5
        .ftop.input.r1.r1.l configure -text $valueLbl
        .ftop.input.r1.r1.e configure -width 8
        pack .ftop.input.r1.r1.e -side right -padx 10
        pack .ftop.input.r1.r1.l -side right
        pack .ftop.input.r1.r1 -side right -padx 20 -anchor w

    }
    
    proc packTransducerTest {value1Lbl value2Lbl cancelBtn passBtn \
                                   failBtn gifFilename} {

        global tclPath
        image create photo embdImage \
            -file ${tclPath}embeddedgif/$gifFilename
        label .ftop.display.image1 -image embdImage
        pack .ftop.display.image1 -side bottom -anchor s \
                                               -fill both -expand yes
        pack .ftop.display -side top -padx 5 -fill both -expand yes

        SnazzyButton::setText .ftop.input.r1.cancel $cancelBtn 0.5
        SnazzyButton::setText .ftop.input.r1.pass $passBtn 0.5
        SnazzyButton::setText .ftop.input.r1.fail $failBtn 0.5
        pack .ftop.input.r1.cancel -side left -anchor sw
        pack .ftop.input.r1.pass -side right -anchor se
        pack .ftop.input.r1.fail -side right -anchor se -padx 5
        .ftop.input.r1.r1.l configure -text $value1Lbl
        .ftop.input.r1.r2.l configure -text $value2Lbl
        .ftop.input.r1.r1.e configure -width 8
        .ftop.input.r1.r2.e configure -width 8
        pack .ftop.input.r1.r1.e -side right -padx 10
        pack .ftop.input.r1.r1.l -side right
        pack .ftop.input.r1.r2.e -side right -padx 10
        pack .ftop.input.r1.r2.l -side right
        pack .ftop.input.r1.r1 -side top -pady 20 -padx 20 -anchor w
        pack .ftop.input.r1.r2 -side bottom -pady 15 -padx 20 -anchor w

    }
 
    proc packArticulatedMeasurements {value1Lbl value2Lbl changeBtn \
                         cancelBtn continueBtn gifFilename} {

        global tclPath
        image create photo embdImage \
            -file ${tclPath}embeddedgif/$gifFilename
        label .ftop.display.image1 -image embdImage
        pack .ftop.display.image1 -side bottom -anchor s \
                                               -fill both -expand yes
        pack .ftop.display -side top -padx 5 -fill both -expand yes

        SnazzyButton::setText .ftop.input.r1.cancel $cancelBtn 0.5
        SnazzyButton::setText .ftop.input.r1.accept $continueBtn 0.5
        SnazzyButton::setText .ftop.input.r1.r1.b $changeBtn 0.5
        SnazzyButton::setText .ftop.input.r1.r2.b $changeBtn 0.5
        pack .ftop.input.r1.cancel -side left -anchor sw
        pack .ftop.input.r1.accept -side right -anchor se
        .ftop.input.r1.r1.l configure -text $value1Lbl
        .ftop.input.r1.r2.l configure -text $value2Lbl
        .ftop.input.r1.r1.e configure -width 15
        .ftop.input.r1.r2.e configure -width 15
        pack .ftop.input.r1.r1.b -side right
        pack .ftop.input.r1.r1.e -side right
        pack .ftop.input.r1.r1.l -side right
        pack .ftop.input.r1.r2.b -side right
        pack .ftop.input.r1.r2.e -side right
        pack .ftop.input.r1.r2.l -side right
        pack .ftop.input.r1.r2 -side bottom -padx 5 -pady 5 -anchor w
        pack .ftop.input.r1.r1 -side bottom -padx 5 -pady 5 -anchor w

    }

    proc packHardLeftHardRightTest {cancelBtn continueBtn gifFilename} {

        global tclPath
        image create photo embdImage \
            -file ${tclPath}embeddedgif/$gifFilename
        label .ftop.display.image1 -image embdImage
        pack .ftop.display.image1 -side bottom -anchor s \
                                               -fill both -expand yes
        pack .ftop.display -side top -padx 5 -fill both -expand yes

        SnazzyButton::setText .ftop.input.r1.cancel $cancelBtn 0.5
        SnazzyButton::setText .ftop.input.r1.accept $continueBtn 0.5
        pack .ftop.input.r1.cancel -side left -anchor sw
        pack .ftop.input.r1.accept -side right -anchor se

    }

    proc packHardLeftHardRightTest2 {cancelBtn passBtn backBtn failBtn \
                                     gifFilename} {

        global tclPath
        image create photo embdImage \
            -file ${tclPath}embeddedgif/$gifFilename
        label .ftop.display.image1 -image embdImage
        pack .ftop.display.image1 -side bottom -anchor s \
                                               -fill both -expand yes

        SnazzyButton::setText .ftop.input.r1.cancel $cancelBtn 0.5
        SnazzyButton::setText .ftop.input.r1.pass $passBtn 0.5
        SnazzyButton::setText .ftop.input.r1.back $backBtn 0.5
        SnazzyButton::setText .ftop.input.r1.fail $failBtn 0.5
        pack .ftop.input.r1.cancel -side left -anchor sw
        pack .ftop.input.r1.back -side left -anchor sw -padx 5
        pack .ftop.input.r1.pass -side right -anchor se
        pack .ftop.input.r1.fail -side right -anchor se -padx 5
        pack .ftop.input.r2.left -side left -padx 10
        pack .ftop.input.r2.stop -side left -padx 20
        pack .ftop.input.r2.right -side left -padx 10
        
        pack .ftop.input.r2 -side top -padx 10
        pack .ftop.display -side top -padx 5 -fill both -expand yes
    }

    proc packManualSteeringDiagnosis {title backBtn gifFilename} {

        .ftop.display.title configure -text $title
        pack .ftop.display.title -side top -padx 5 -pady 5
        global tclPath
        image create photo embdImage \
            -file ${tclPath}embeddedgif/$gifFilename
        label .ftop.display.image1 -image embdImage
        pack .ftop.display.image1 -side bottom -anchor s \
                                               -fill both -expand yes
        pack .ftop.display -side top -padx 5 -fill both -expand yes

        SnazzyButton::setText .ftop.input.r1.back $backBtn 0.5
        pack .ftop.input.r1.back -side left -anchor sw
    }

    proc packWheelAngleSensorTestDiagnosis {title backBtn gifFilename} {

        .ftop.display.title configure -text $title
        pack .ftop.display.title -side top -padx 5 -pady 5
        global tclPath
        image create photo embdImage \
            -file ${tclPath}embeddedgif/$gifFilename
        label .ftop.display.image1 -image embdImage
        pack .ftop.display.image1 -side bottom -anchor s \
                                               -fill both -expand yes
        pack .ftop.display -side top -padx 5 -fill both -expand yes

        SnazzyButton::setText .ftop.input.r1.back $backBtn 0.5
        pack .ftop.input.r1.back -side left -anchor sw
    }

    proc packTransducerTestDiagnosis {title backBtn gifFilename} {

        .ftop.display.title configure -text $title
        pack .ftop.display.title -side top -padx 5 -pady 5
        global tclPath
        image create photo embdImage \
            -file ${tclPath}embeddedgif/$gifFilename
        label .ftop.display.image1 -image embdImage
        pack .ftop.display.image1 -side bottom -anchor s \
                                               -fill both -expand yes
        pack .ftop.display -side top -padx 5 -fill both -expand yes

        SnazzyButton::setText .ftop.input.r1.back $backBtn 0.5
        pack .ftop.input.r1.back -side left -anchor sw
    }

    proc packHardLeftHardRightDiagnosis {title backBtn \
                                         gifFilename} {

        .ftop.display.title configure -text $title
        pack .ftop.display.title -side top -padx 5 -pady 5
        global tclPath
        image create photo embdImage \
            -file ${tclPath}embeddedgif/$gifFilename
        label .ftop.display.image1 -image embdImage
        pack .ftop.display.image1 -side bottom -anchor s \
                                               -fill both -expand yes
        pack .ftop.display -side top -padx 5 -fill both -expand yes

        SnazzyButton::setText .ftop.input.r1.back $backBtn 0.5
        pack .ftop.input.r1.back -side left -anchor sw
    }

    
    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------

    proc actDisplayWheelBase {wheelbase} {
        .ftop.input.r1.r1.e configure -text $wheelbase
    }

    proc actDisplayArticulatedMeasurements {mea1 mea2} {
        .ftop.input.r1.r1.e configure -text $mea1
        .ftop.input.r1.r2.e configure -text $mea2
    }

    proc actDisplayWheelAngle {wheelangle} {
        .ftop.input.r1.r1.e configure -text $wheelangle
    }

    proc actDisplayTransducer {transducer1 transducer2} {
        .ftop.input.r1.r1.e configure -text $transducer1
        .ftop.input.r1.r2.e configure -text $transducer2
    }

    proc actDisplayLeverArm {leverarm} {
        .ftop.input.r1.r1.e configure -text $leverarm
    }
}
