##############################################################################
#
# vc/src/tcl/tbd.tcl
#
# A global catch-all script for deferred Tcl coding decisions.
#
# 20020327 MLE - created
#
# Copyright (c) 2002 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################

# Variables related to the win size
set inputWidth $winWidth                             ;# Input frame dimensions
set inputHeight 225
set displayWidth $winWidth                         ;# Display frame dimensions
set displayHeight 75
set navWidth 265                                       ;# Nav frame dimensions
set navHeight [expr $winHeight - $inputHeight - $displayHeight]
set configWidth [expr $winWidth - $navWidth]        ;# Config frame dimensions
set configHeight $navHeight

# beepOnce procedure
proc beepOnce {} {
    global isUserDisplay
    if {$isUserDisplay} {            ;# only beep if we're on a real box
        bell;
    }
}

proc ConvertToMeters { value units } {
    if {$units == "feet"} {
	return [expr $value*12*2.54/100];  # THIS IS EXACT
    } elseif {$units == "inches"} {
	return [expr $value*2.54/100];     # THIS IS EXACT
    } else {
	if {$units != "meters"} {
	    puts stderr "modes.tcl:ConvertToMeters: units == $units";
	}
	return $value;
    }
}

